-- Create namespace
DsRGuildHall = {}
local DsRGuildHall = DsRGuildHall or {}

-- Name for registering events
DsRGuildHall.name        = "DsRGuildHall"
DsRGuildHall.version     = "2024.06.22"
DsRGuildHall.DisplayName = "DsR GuildRoster"
DsRGuildHall.Author      = "Hasenwarrior"

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
local function OnGroupScroll()
	if ZO_GuildRoster:IsHidden() == false then zo_callLater(DsRGuildRoster.UpdateGuildRosterList, 250) end
end

-- Initialization function
function DsRGuildHall:Initialize()
    DsRGuildHall.scene_fragment        = ZO_SimpleSceneFragment:New(DsRGuildHallFrame)
    DsRGuildHall.scene_fragmentHoliday = ZO_SimpleSceneFragment:New(DsRGuildHolidayFrame)
    DsRGuildHall.scene_fragmentAdmin   = ZO_SimpleSceneFragment:New(DsRGuildAdminFrame)
    DsRGuildHall.scene_fragmentInfo    = ZO_SimpleSceneFragment:New(DsRGuildInfoFrame)
    DsRGuildHall.scene_fragmentRaid    = ZO_SimpleSceneFragment:New(DsRGuildRaidFrame)
    DsRGuildHall.scene_fragmentLead    = ZO_SimpleSceneFragment:New(DsRGuildLeaderFrame)
  
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragment)
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragmentHoliday)
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragmentAdmin)
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragmentInfo)
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragmentRaid)
    GUILD_HOME_SCENE:AddFragment(DsRGuildHall.scene_fragmentLead)

    GUILD_ROSTER_SCENE:AddFragment(DsRGuildHall.scene_fragmentHoliday)
    
    GUILD_RANKS_SCENE:AddFragment(DsRGuildHall.scene_fragmentHoliday)
    
    KEYBOARD_GUILD_RECRUITMENT_SCENE:AddFragment(DsRGuildHall.scene_fragmentHoliday)
    
    EVENT_MANAGER:UnregisterForEvent(DsRGuildHall.name, EVENT_ADD_ON_LOADED)
    
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildHall.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildAdmin.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildHoliday.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildInfo.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildRoster.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildRaid.OnGuildIdChanged)
    ZO_PreHook(GUILD_ROSTER_MANAGER, "OnGuildIdChanged", DsRGuildLeader.OnGuildIdChanged)

    ZO_PostHook(GUILD_ROSTER_MANAGER, "RefreshAll", DsRGuildRoster.UpdateGuildRosterList)
    GUILD_ROSTER_SCENE:RegisterCallback("StateChange", DsRGuildRoster.OnSceneChange)
    ZO_PreHook("ZO_ScrollList_UpdateScroll", OnGroupScroll)

    DsRdefaults:Defaults()

    DsRslashcmd.createSlashCommands()
    -- DsRslashcmd.cmd.createSlashCommands()

    DsRMenu:SetupMenueSettings()

    DsRGuildHall.InitKeybinds()
end

function DsRGuildHall.InitKeybinds()
    ZO_CreateStringId("SI_BINDING_NAME_DSRGUILD_BINDALL_UNKNOWN", GetString(DsRGuildBind_bindunknown))
    ZO_CreateStringId("SI_BINDING_NAME_DSRGUILD_POSTALL_UNBOUNTED", GetString(DsRGuildBind_postunbounted))
    ZO_CreateStringId("SI_BINDING_NAME_DSRGUILD_TOGGLE_INVENTORY_ASSISTANT", GetString(DsRGuildInventory_Open))
    ZO_CreateStringId("SI_BINDING_NAME_DSRGUILD_TOGGLE_INVENTORY_ASSISTANT_NOFOCUS", GetString(DsRGuildInventory_OpenGrab))
    ZO_CreateStringId("SI_BINDING_NAME_DSRGUILD_PORT_TO_CYRO", GetString(DsRGuildPvP_ap_telvarSaverKeybindmsg))
end

-- Startup function
function DsRGuildHall.OnGuildDataLoaded(event_code, guild_id)
    --Note: This event only fires on startup, not on /reloadui
end

-- Event handlers
local function OnAddonLoaded(event, addonName)
    if (addonName ~= DsRGuildHall.name) then return end

    DsRGuildHall:Initialize()
        
    local ld = os.date("*t")
    local myGuildTextColor = "9fb6cd"
    local myEventTextColor = "ff4c4c"
    local myTextColor      = "FDFEFE"
  
    local myGuildText = "Die sieben Raben"


-- Valentine's Day
    if ld.month == 2 and ld.day == 14 then
        local myText      = GetString(DsR_valentinTXT)
        local myEventText = GetString(DsR_valentinEvent)
        local myPicture   = "DsRGuildHall/misc/DsR/DsR_valentin.dds"
        Guild   = string.format("|c%s%s|r", myGuildTextColor, myGuildText)
        Message = string.format("|c%s%s|r\n|c%s%s|r", myTextColor, myText, myEventTextColor, myEventText)
        Picture = string.format("%s", myPicture)
-- Ester
    elseif (ld.month == 3 and ld.day >= 20) and (ld.month == 4 and ld.day <= 1) then
        local myText      = GetString(DsR_esterTXT)
        local myEventText = GetString(DsR_esterEvent)
        local myPicture   = "DsRGuildHall/misc/DsR/DsR_ester.dds"
        Guild   = string.format("|c%s%s|r", myGuildTextColor, myGuildText)
        Message = string.format("|c%s%s|r\n|c%s%s|r", myTextColor, myText, myEventTextColor, myEventText)
        Picture = string.format("%s", myPicture)
-- Halloween
    elseif ld.month == 10 and ld.day == 31 then
        local myText      = GetString(DsR_halloweenTXT)
        local myEventText = GetString(DsR_halloweenEvent)
        local myPicture   = "DsRGuildHall/misc/DsR/DsR_normal.dds"
        Guild   = string.format("|c%s%s|r", myGuildTextColor, myGuildText)
        Message = string.format("|c%s%s|r\n|c%s%s|r", myTextColor, myText, myEventTextColor, myEventText)
        Picture = string.format("%s", myPicture)
-- Christmas
    elseif ld.month == 12 and ld.day >= 23 and ld.day <= 26 then
        local myText      = GetString(DsR_xmasTXT)
        local myEventText = GetString(DsR_xmasEvent)
        local myPicture   = "DsRGuildHall/misc/DsR/DsR_xmas.dds"
        Guild   = string.format("|c%s%s|r", myGuildTextColor, myGuildText)
        Message = string.format("|c%s%s|r\n|c%s%s|r", myTextColor, myText, myEventTextColor, myEventText)
        Picture = string.format("%s", myPicture)
-- New year
    elseif (ld.month == 1 and ld.day >= 0) and (ld.month == 1 and ld.day <= 3) then
        local myText      = GetString(DsR_newyearTXT)
        local myEventText = GetString(DsR_newyearEvent)
        local myPicture   = "DsRGuildHall/misc/DsR/DsR_normal.dds"
        Guild   = string.format("|c%s%s|r", myGuildTextColor, myGuildText)
        Message = string.format("|c%s%s|r\n|c%s%s|r", myTextColor, myText, myEventTextColor, myEventText)
        Picture = string.format("%s", myPicture)
    else
        local myText      = ""
        local myEventText = ""
        local myPicture   = ""
    end
    if myEventText == "" then
    else
        CENTER_SCREEN_ANNOUNCE:AddMessage(1, CSA_CATEGORY_MAJOR_TEXT, SOUNDS.LEVEL_UP, Guild, nil, Picture, nil, nil, nil, 20000)
        CENTER_SCREEN_ANNOUNCE:AddMessage(2, CSA_CATEGORY_MAJOR_TEXT, nil, nil, Message, nil, nil, nil, nil, 20000)
    end 
    
    if HodorReflexes then
        local player   = HodorReflexes.player
        local userId   = GetUnitDisplayName('player')
        local userIcon = player.GetIconForUserId(userId)
        
        if userIcon then
            DsRGuildHallHodorIcon:SetTexture(userIcon)
            DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHall.GoToDsRGuildHall, BOTTOM, 0, 10)
        else
            DsRGuildHallHodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
            DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHall.GoToDsRGuildHall, BOTTOM, 0, 10)
        end
    else
        DsRGuildHallHodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
        DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHall.GoToDsRGuildHall, BOTTOM, 0, 10)
    end

	-- Change the width of the RosterWindow
    ZO_KeyboardFriendsList:SetWidth(950)

    -- Change the width of the Tooltip
    ItemTooltip:SetDimensionConstraints(470, 0, 470, 1440)
    PopupTooltip:SetDimensionConstraints(470, 0, 470, 1440)
    
    DsRGuildRoster.ModifyGuildMemberMenuHeader()
    DsRGuildRoster.CustomRoster()
    
    DsRGuildMail.OnAddonLoaded()
    DsRGuildFriends.OnAddonLoaded()
    DsRGuildGroup.OnAddonLoaded()
    DsRGuildLoot.OnAddonLoaded()
    DsRGuildBind.OnAddOnLoaded()
    DsRGuildBeamHandlers.OnAddOnLoaded()
    DsRGuildPvP.OnAddonLoaded()
    DsRGuildPvPstatus.Initialize()
    DsRGuildPvPdoor.OnAddonLoaded()
    DsRGuildReminder.OnAddOnLoaded()
    IA_InventoryAssistant_OnInitialize()
    DsRGuildAchievTracker.OnAddonLoaded()
    DsRPvPBossTimer.OnAddOnLoaded()
    DsRGuildPrecrafter.OnAddOnLoaded()
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- change guild
function DsRGuildHall.OnGuildIdChanged(guild_roster_manager)
    local guildId   = GUILD_ROSTER_MANAGER:GetGuildId()
    local guildName = GetGuildName(guildId)

    if not guild_roster_manager then
        ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.GENERAL_ALERT_ERROR, zo_strformat(gettext.gettext("Can't identify the guild hall yet")))
        return
    end
    if not guildId then
        return
    end

    local name          = DsRGuildHallName
    local HALLname      = DsRGuild
    local Icon          = DsRGuildHallIcon
    local GoToButton    = GoToDsRGuildHall
    local HodorIcon     = DsRGuildHallHodorIcon
    local GoToButtonMem = GoToDsRGuildHallMem
    local GuildMail     = DsRGuildHallPostButton
    
    if guildName ~= "Die sieben Raben" then
        name:SetHidden(true)
        HALLname:SetHidden(true)
        Icon:SetHidden(true)
        GoToButton:SetHidden(true)
        
        if HodorReflexes then
            local player   = HodorReflexes.player
            local userId   = GetUnitDisplayName('player')
            local userIcon = player.GetIconForUserId(userId)

            if userIcon then
				HodorIcon:SetTexture(userIcon)
                HodorIcon:SetAnchor(TOP, HALLname, TOP, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            else
                HodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
                HodorIcon:SetAnchor(TOP, HALLname, TOP, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            end
        else
            HodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
            HodorIcon:SetAnchor(TOP, HALLname, TOP, 0, 10)
            GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
        end
    else
        name:SetHidden(false)
        HALLname:SetHidden(false)
        Icon:SetHidden(false)
        GoToButton:SetHidden(false)
    
        if HodorReflexes then
            local player   = HodorReflexes.player
            local userId   = GetUnitDisplayName('player')
            local userIcon = player.GetIconForUserId(userId)
        
            if userIcon then
				HodorIcon:SetTexture(userIcon)
                HodorIcon:SetAnchor(TOP, GoToButton, BOTTOM, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            else
                HodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
                HodorIcon:SetAnchor(TOP, GoToButton, BOTTOM, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            end
        else
            HodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
            HodorIcon:SetAnchor(TOP, GoToButton, BOTTOM, 0, 10)
            GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
        end
 
        HALLname:SetText(GetString(DsR_Guild))
        GoToButton:SetText(GetString(DsR_Hall))
        GoToButtonMem:SetText(GetString(DsR_HallMem))
        GuildMail:SetText(GetString(DsR_Post))
    end
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Special textures for event days

-- Logo
function DsRGuildHall.LoadIcon()
    local Icon = DsRGuildHallIcon
    local ld   = os.date("*t")
    
    if ld.month == 2 and ld.day == 14 then
-- Valentine's Day
        Icon:SetTexture("DsRGuildHall/misc/DsR/DsR_valentin.dds")
    elseif (ld.month == 3 and ld.day >= 20) and (ld.month == 4 and ld.day <= 1) then
-- Ester
        Icon:SetTexture("DsRGuildHall/misc/DsR/DsR_ester.dds")
    elseif ld.month == 12 and ld.day >= 0 and ld.day <= 26 then
-- Christmas
        Icon:SetTexture("DsRGuildHall/misc/DsR/DsR_xmas.dds")
    else
        Icon:SetTexture("DsRGuildHall/misc/DsR/DsR_normal.dds")
    end
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Check first guild
function DsRGuildHall.Check()
    local guildId   = GUILD_ROSTER_MANAGER:GetGuildId()
    local guildName = GetGuildName(guildId)

    local name          = DsRGuildHallName
    local HALLname      = DsRGuild
    local Icon          = DsRGuildHallIcon
    local GoToButton    = GoToDsRGuildHall
    local GoToButtonMem = GoToDsRGuildHallMem
    local GuildMail     = DsRGuildHallPostButton
    
    GoToButtonMem:SetText(GetString(DsR_HallMem))
    GuildMail:SetText(GetString(DsR_Post))
    
    if guildName ~= "Die sieben Raben" then
        name:SetHidden(true)
        HALLname:SetHidden(true)
        Icon:SetHidden(true)
        GoToButton:SetHidden(true)
        
        if HodorReflexes then
            local player   = HodorReflexes.player
            local userId   = GetUnitDisplayName('player')
            local userIcon = player.GetIconForUserId(userId)

            if userIcon then
				DsRGuildHallHodorIcon:SetTexture(userIcon)
                DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHallFrame, TOP, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            else
                DsRGuildHallHodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
                DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHallFrame, TOP, 0, 10)
                GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
            end
        else
            DsRGuildHallHodorIcon:SetTexture("/esoui/art/worldmap/map_indexicon_housing_up.dds")
            DsRGuildHallHodorIcon:SetAnchor(TOP, DsRGuildHallFrame, TOP, 0, 10)
            GoToButtonMem:SetAnchor(TOP, HodorIcon, BOTTOM, 0, 5)
        end
    else
        name:SetHidden(false)
        HALLname:SetHidden(false)
        Icon:SetHidden(false)
        GoToButton:SetHidden(false)
        
        HALLname:SetText(GetString(DsR_Guild))
        GoToButton:SetText(GetString(DsR_Hall))
    
        DsRGuildHall.LoadIcon()
    end
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Register event handler
EVENT_MANAGER:RegisterForEvent(DsRGuildHall.name, EVENT_ADD_ON_LOADED, OnAddonLoaded)
