-- Create namespace
DsRMenu = {}
local DsRMenu = DsRMenu  or {}

local LAM     = LibAddonMenu2
local LMP     = LibMapPins

DsRMenu.name = "DsRMenu"

function DsRMenu:SetupMenueSettings()
	local panelData = {
		type				= "panel",
		name 				= "DsR GuildRoster",
		displayName 		= zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_normal.dds") .. "|c9fb6cdDsR GuildRoster|r",
		author 				= "|cD8F781Has|r|cF3F781enw|r|cF5DA81arr|r|cF7BE81ior|r",
		version				= DsRGuildHall.version,
		slashCommand 		= "/dsrsettings",
		registerForRefresh	= true,
		registerForDefaults	= true,
		website 			= "https://www.esoui.com/downloads/info3776-DsRGuildRoster.html",
        feedback            = "https://www.esoui.com/downloads/info3776-DsRGuildRoster.html#comments"
	}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- SLASH COMMANDS
-------------------------------------------------------------------------------------------------------------------------------------------------
local Chatcommands = {
    {
        type 	 = "description",
        text     = GetString(DsRGuildMenue_accKeybind) .. "\n" .. GetString(DsRGuildMenue_accKeybindinv)
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_slashDESC1) .. "\n" .. GetString(DsRGuildBind_slashDESC2)
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_slashdsrim)
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildPvP_ap_telvarSaverKeybind)
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_slashDESC3)
    },
}
-------------------------------------------------------------------------------------------------------------------------------------------------
-- LootManager - CenterScreen
-------------------------------------------------------------------------------------------------------------------------------------------------
local LootManagerScreen = {
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/icons/crafting_potent_nirncrux_stone.dds", 26, 26) .. GetString(DsRGuildLoot_fortified_nirncrux),
        getFunc  = function() return DsRGuildLoot.sV.ScreenfNirn end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenfNirn = val end,
        width    = "full"
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/icons/crafting_potent_nirncrux_dust.dds", 26, 26) .. GetString(DsRGuildLoot_potent_nirncrux),
        getFunc  = function() return DsRGuildLoot.sV.ScreensNirn end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreensNirn = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crafting_components_runestones_001.dds", 26, 26) .. GetString(DsRGuildLoot_kuta),
        getFunc  = function() return DsRGuildLoot.sV.ScreenKuta end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenKuta = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crafting_components_runestones_058.dds", 26, 26) .. GetString(DsRGuildLoot_hakeijo),
        getFunc  = function() return DsRGuildLoot.sV.ScreenHakeijo end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenHakeijo = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/item_grimoire_ink.dds", 26, 26) .. GetString(DsRGuildLoot_LuminousInk),
        getFunc  = function() return DsRGuildLoot.sV.ScreenLuminousInk end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenLuminousInk = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/currency_seals_of_endeavor_32.dds", 26, 26) .. GetString(DsRGuildLoot_endeavor),
        getFunc  = function() return DsRGuildLoot.sV.ScreenBestrebung end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenBestrebung = val end,
        width    = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildLoot_screenloot_deactivate),
        getFunc  = function() return DsRGuildLoot.sV.ScreenOnOff end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenOnOff = val end,
        width    = "full"
    },
    {
        type 	 = "dropdown",
        name 	 = GetString(DsRGuildLoot_own_loot_quali),
        choices  = {"1 - Normal", "2 - |c00FF00Erlesen|r", "3 - |c259EFAÜberragend|r", "4 - |c8525FAEpisch|r", "5 - |cF7C42ALegendär|r"},
        getFunc  = function() return DsRGuildLoot.sV.ScreenQualiloot end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenQualiloot = val end,
        width    = "full",
        disabled = function() return DsRGuildLoot.sV.ScreenOnOff end
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- LootManager - Chat
-------------------------------------------------------------------------------------------------------------------------------------------------
local LootManagerChat = {
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/icons/crafting_potent_nirncrux_stone.dds", 26, 26) .. GetString(DsRGuildLoot_fortified_nirncrux),
        getFunc  = function() return DsRGuildLoot.sV.ChatfNirn end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatfNirn = val end,
        width    = "full"
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/icons/crafting_potent_nirncrux_dust.dds", 26, 26) .. GetString(DsRGuildLoot_potent_nirncrux),
        getFunc  = function() return DsRGuildLoot.sV.ChatsNirn end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatsNirn = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crafting_components_runestones_001.dds", 26, 26) .. GetString(DsRGuildLoot_kuta),
        getFunc  = function() return DsRGuildLoot.sV.ChatKuta end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatKuta = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crafting_components_runestones_058.dds", 26, 26) .. GetString(DsRGuildLoot_hakeijo),
        getFunc  = function() return DsRGuildLoot.sV.ChatHakeijo end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatHakeijo = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/item_grimoire_ink.dds", 26, 26) .. GetString(DsRGuildLoot_LuminousInk),
        getFunc  = function() return DsRGuildLoot.sV.ChatLuminousInk end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatLuminousInk = val end,
        width    = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildLoot_chatloot_deactivate),
        getFunc  = function() return DsRGuildLoot.sV.ChatOnOff end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatOnOff = val end,
        width    = "half"
    },
    {
        type 	 = "dropdown",
        name 	 = GetString(DsRGuildLoot_own_loot_quali),
        choices  = {"1 - Normal", "2 - |c00FF00Erlesen|r", "3 - |c259EFAÜberragend|r", "4 - |c8525FAEpisch|r", "5 - |cF7C42ALegendär|r"},
        getFunc  = function() return DsRGuildLoot.sV.ChatQualiloot end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatQualiloot = val end,
        width    = "half",
        disabled = function() return DsRGuildLoot.sV.ChatOnOff end
    },
    {
        type 	= "checkbox",
        name 	= GetString(DsRGuildLoot_group_loot_deactivate),
        getFunc  = function() return DsRGuildLoot.sV.ChatGroupLoot end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatGroupLoot = val end,
        width    = "half"
    },
    {
        type 	= "dropdown",
        name 	= GetString(DsRGuildLoot_group_loot_quali),
        choices  = {"1 - Normal", "2 - |c00FF00Erlesen|r", "3 - |c259EFAÜberragend|r", "4 - |c8525FAEpisch|r", "5 - |cF7C42ALegendär|r"},
        getFunc  = function() return DsRGuildLoot.sV.ChatQualiGroupLoot end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatQualiGroupLoot = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatGroupLoot end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_XP.dds", 26, 26) .. GetString(DsRGuildLoot_experience_gain),
        getFunc  = function() return DsRGuildLoot.sV.ChatXP end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXP = val end,
        width    = "half"
    },
    {
        type        = 'editbox',
        name        = GetString(DsRGuildLoot_experience_gainTXT),
        getFunc     = function() return DsRGuildLoot.sV.ChatXPtxt end,
        setFunc     = function(value) DsRGuildLoot.sV.ChatXPtxt = value end,
        isMultiline = false,
        width       = "half",
        disabled    = function() return not DsRGuildLoot.sV.ChatXP end
    },
    {
        type 	= "checkbox",
        name 	= zo_iconFormat("/esoui/art/currency/currency_gold.dds", 26, 26) .. GetString(DsRGuildLoot_gold_gain),
        getFunc  = function() return DsRGuildLoot.sV.ChatGold end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatGold = val end,
        width    = "half"
    },
    {
        type        = 'editbox',
        name        = GetString(DsRGuildLoot_gold_gainTXT),
        getFunc     = function() return DsRGuildLoot.sV.ChatGoldtxt end,
        setFunc     = function(value) DsRGuildLoot.sV.ChatGoldtxt = value end,
        isMultiline = false,
        width       = "half",
        disabled    = function() return not DsRGuildLoot.sV.ChatGold end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/undauntedkey.dds", 26, 26) .. GetString(DsRGuildLoot_undauntedkeys),
        getFunc  = function() return DsRGuildLoot.sV.ChatUnerschrocken end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatUnerschrocken = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/icon_eventticket_loot.dds", 26, 26) .. GetString(DsRGuildLoot_event_Tickets),
        getFunc  = function() return DsRGuildLoot.sV.Chatetickets end,
        setFunc  = function(val) DsRGuildLoot.sV.Chatetickets = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/currency_seedcrystal_mipmap.dds", 26, 26) .. GetString(DsRGuildLoot_transmute_crystals),
        getFunc  = function() return DsRGuildLoot.sV.ChatTransmut end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatTransmut = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/currency_seals_of_endeavor_32.dds", 26, 26) .. GetString(DsRGuildLoot_endeavor),
        getFunc  = function() return DsRGuildLoot.sV.ChatBestrebung end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatBestrebung = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/currency/archivalfragments_mipmaps.dds", 26, 26) .. GetString(DsRGuildLoot_archival_fortunes),
        getFunc  = function() return DsRGuildLoot.sV.ChatEndless end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatEndless = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/tutorial/journal_tabicon_achievements_up.dds", 26, 26) .. GetString(DsRGuildLoot_completed_Achievements),
        getFunc  = function() return DsRGuildLoot.sV.ChatArchivments end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatArchivments = val end,
        width    = "half"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/tutorial/journal_tabicon_achievements_up.dds", 26, 26) .. GetString(DsRGuildLoot_progress_Achievements),
        getFunc  = function() return DsRGuildLoot.sV.ChatArchivmentsStatus end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatArchivmentsStatus = val end,
        width    = "half"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/housing_bre_inc_book_open001.dds", 26, 26) .. GetString(DsRGuildLoot_bookloot),
        getFunc  = function() return DsRGuildLoot.sV.ChatBookLoot end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatBookLoot = val end,
        width    = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_XP.dds", 26, 26) .. GetString(DsRGuildLoot_experience_skills),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPskills end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPskills = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/ability_weapon_016.dds", 26, 26) .. GetString(DsRGuildLoot_exp_WEAPON),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPweapon end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPweapon = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/passive_armor_012.dds", 26, 26) .. GetString(DsRGuildLoot_exp_ARMOR),
        getFunc  = function() return DsRGuildLoot.sV.ChatXParmor end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXParmor = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crownstore_skillline_fightersguild.dds", 26, 26) .. GetString(DsRGuildLoot_exp_GUILD),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPguild end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPguild = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/crownstore_skillline_alliancewar_assault.dds", 26, 26) .. GetString(DsRGuildLoot_exp_AVA),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPava end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPava = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/u26_ability_digging_02.dds", 26, 26) .. GetString(DsRGuildLoot_exp_Excavation),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPexcavation end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPexcavation = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/ability_scrying_02.dds", 26, 26) .. GetString(DsRGuildLoot_exp_Scrying),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPscrying end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPscrying = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_ledgermain.dds", 26, 26) .. GetString(DsRGuildLoot_exp_Legerdemain),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPlegerdemain end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPlegerdemain = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/soulgem_006_filled.dds", 26, 26) .. GetString(DsRGuildLoot_exp_SoulMagic),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPsoulmagic end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPsoulmagic = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/ability_vampire_007.dds", 26, 26) .. GetString(DsRGuildLoot_exp_Vampire),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPvampire end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPvampire = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/ability_werewolf_010.dds", 26, 26) .. GetString(DsRGuildLoot_exp_Werewolf),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPwerewolf end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPwerewolf = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPskills end
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_XP.dds", 26, 26) .. GetString(DsRGuildLoot_experience_crafting),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPcrafting end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPcrafting = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_alchemy.dds", 26, 26) .. GetString(DsRGuildLoot_exp_alchemy),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPalchemy end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPalchemy = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_blacksmithing.dds", 26, 26) .. GetString(DsRGuildLoot_exp_blacksmithing),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPblacksmithing end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPblacksmithing = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_woodworking.dds", 26, 26) .. GetString(DsRGuildLoot_exp_woodworking),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPwoodworking end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPwoodworking = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_clothier.dds", 26, 26) .. GetString(DsRGuildLoot_exp_clothier),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPclothier end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPclothier = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_enchanting.dds", 26, 26) .. GetString(DsRGuildLoot_exp_enchanting),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPenchanting end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPenchanting = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_jewelrymaking.dds", 26, 26) .. GetString(DsRGuildLoot_exp_jewelrymaking),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPjewelrymaking end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPjewelrymaking = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_provisioner.dds", 26, 26) .. GetString(DsRGuildLoot_exp_provisioner),
        getFunc  = function() return DsRGuildLoot.sV.ChatXPprovisioner end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatXPprovisioner = val end,
        width    = "half",
        disabled = function() return not DsRGuildLoot.sV.ChatXPcrafting end
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- LootManager - Trading
-------------------------------------------------------------------------------------------------------------------------------------------------
local LootManagerTrading = {
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/tradehammer.dds", 26, 26) .. GetString(DsRGuildLoot_trade_chat),
        getFunc  = function() return DsRGuildLoot.sV.ChatTradePrice end,
        setFunc  = function(val) DsRGuildLoot.sV.ChatTradePrice = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/tradehammer.dds", 26, 26) .. GetString(DsRGuildLoot_trade_screen),
        getFunc  = function() return DsRGuildLoot.sV.ScreenTradePrice end,
        setFunc  = function(val) DsRGuildLoot.sV.ScreenTradePrice = val end,
        width    = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildLoot_trade_support)
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- LootManager - Stickerbook and Bind
-------------------------------------------------------------------------------------------------------------------------------------------------
local StickerBind = {
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_autobindloot),
        getFunc = function() return DsRGuildBind.bind.autoBind end,
        setFunc = function(value) DsRGuildBind.bind.autoBind = value end,
        width   = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_Iconshowin)
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_bag),
        tooltip = GetString(DsRGuildBind_show_bagTP),
        getFunc = function() return DsRGuildBind.bind.showbag end,
        setFunc = function(value)
            DsRGuildBind.bind.showbag = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_trading),
        tooltip = GetString(DsRGuildBind_show_tradingTP),
        getFunc = function() return DsRGuildBind.bind.showtrading end,
        setFunc = function(value)
            DsRGuildBind.bind.showtrading = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_bank),
        tooltip = GetString(DsRGuildBind_show_bankTP),
        getFunc = function() return DsRGuildBind.bind.showbank end,
        setFunc = function(value)
            DsRGuildBind.bind.showbank = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_housebank),
        tooltip = GetString(DsRGuildBind_show_housebankTP),
        getFunc = function() return DsRGuildBind.bind.showhousebank end,
        setFunc = function(value)
            DsRGuildBind.bind.showhousebank = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_guildbank),
        tooltip = GetString(DsRGuildBind_show_guildbankTP),
        getFunc = function() return DsRGuildBind.bind.showguild end,
        setFunc = function(value)
            DsRGuildBind.bind.showguild = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_crafting),
        tooltip = GetString(DsRGuildBind_show_craftingTP),
        getFunc = function() return DsRGuildBind.bind.showcrafting end,
        setFunc = function(value)
            DsRGuildBind.bind.showcrafting = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_transmute),
        tooltip = GetString(DsRGuildBind_show_transmuteTP),
        getFunc = function() return DsRGuildBind.bind.showtransmute end,
        setFunc = function(value)
            DsRGuildBind.bind.showtransmute = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_show_guildstore),
        tooltip = GetString(DsRGuildBind_show_guildstoreTP),
        getFunc = function() return DsRGuildBind.bind.showguildstore end,
        setFunc = function(value)
            DsRGuildBind.bind.showguildstore = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_chat_SystemShow),
        tooltip = GetString(DsRGuildBind_chat_SystemShowTP),
        getFunc = function() return DsRGuildBind.bind.chatSystemShow end,
        setFunc = function(value)
            DsRGuildBind.bind.chatSystemShow = value
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_chat_MessageShow),
        tooltip = GetString(DsRGuildBind_chat_MessageShowTP),
        getFunc = function() return DsRGuildBind.bind.chatMessageShow end,
        setFunc = function(value)
            DsRGuildBind.bind.chatMessageShow = value
        end,
        width = "full",
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_Iconposition)
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildBind_pos_iconOffset),
        tooltip = GetString(DsRGuildBind_pos_iconOffsetTP),
        min     = -390,
        max     = 150,
        step    = 10,
        width   = full,
        getFunc = function() return DsRGuildBind.bind.iconOffset end,
        setFunc = function(value)
            DsRGuildBind.bind.iconOffset = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildBind_pos_iconStoreOffset),
        tooltip = GetString(DsRGuildBind_pos_iconStoreOffsetTP),
        min     = -270,
        max     = 330,
        step    = 10,
        width   = full,
        getFunc = function() return DsRGuildBind.bind.iconStoreOffset end,
        setFunc = function(value)
            DsRGuildBind.bind.iconStoreOffset = value
            DsRGuildBind.Mark.OnSetCollectionUpdated()
        end,
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildBind_req_desc)
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_req_showRequestLink),
        tooltip = GetString(DsRGuildBind_req_showRequestLinkTP),
        getFunc = function() return DsRGuildBind.bind.showRequestLink end,
        setFunc = function(value)
            DsRGuildBind.bind.showRequestLink = value
        end,
        width = "full",
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildBind_req_requestInWhisper),
        tooltip = GetString(DsRGuildBind_req_requestInWhisperTP),
        default = true,
        getFunc = function() return DsRGuildBind.bind.requestInWhisper end,
        setFunc = function(value)
            DsRGuildBind.bind.requestInWhisper = value
        end,
        width = "full",
    },
    {
        type    = "editbox",
        name    = GetString(DsRGuildBind_req_requestPrefix),
        tooltip = GetString(DsRGuildBind_req_requestPrefixTP),
        default = "Can I get",
        getFunc = function() return DsRGuildBind.bind.requestPrefix end,
        setFunc = function(value)
            DsRGuildBind.bind.requestPrefix = value
        end,
        isMultiline = false,
        isExtraWide = false,
        width = "full",
        disabled = function() return not DsRGuildBind.bind.showRequestLink end,
    },
}

-----------------------------------------------------------------------------------------------------------
-- PvP - Cyrodiil (AP / TelVar / Warteschlange)
-----------------------------------------------------------------------------------------------------------
local PvPWar = {
    {
        type = "header",
        name = zo_iconFormat("/esoui/art/deathrecap/deathrecap_killingblow_icon.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildMenue_PvPandBGkilling)
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildPvP_KillingBlowScreen),
        getFunc = function() return DsRGuildPvP.pvp.PvPKillScreen end,
        setFunc = function(value)
            DsRGuildPvP.pvp.PvPKillScreen = value
        end,
        width    = "full"
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildPvP_KillingBlowChat),
        getFunc = function()
            return DsRGuildPvP.pvp.PvPKillBlowChat
        end,
        setFunc = function(value)
            DsRGuildPvP.pvp.PvPKillBlowChat = value
        end,
        width    = "full"
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildPvP_KillingChatMenue),
        tooltip = GetString(DsRGuildPvP_KillingChatMenueTP),
        getFunc = function()
            return DsRGuildPvP.pvp.PvPKillChat
        end,
        setFunc = function(value)
            DsRGuildPvP.pvp.PvPKillChat = value
        end,
        width    = "full"
    },
    {
        type    = "checkbox",
        name    = zo_iconFormat("/esoui/art/itemupgrade/eso_itemupgrade_greenslot.dds", 26, 26) .. GetString(DsRGuildPvP_EnableAnimation),
        tooltip = GetString(DsRGuildPvP_EnableAnimationTP),
        getFunc = function()
            return DsRGuildPvP.pvp.PvPKillenableFrame
        end,
        setFunc = function(value)
            DsRGuildPvP.pvp.PvPKillenableFrame = value
        end
    },
    {
        type    = "colorpicker",
        name    = GetString(DsRGuildPvP_ColorAnimation),
        tooltip = GetString(DsRGuildPvP_ColorAnimationTP),
        getFunc = function()
            return unpack(DsRGuildPvP.pvp.PvPKillframeColor)
        end,
        setFunc = function(r, g, b, a)
            DsRGuildPvP.pvp.PvPKillframeColor = {r, g, b, a}
            DSR_KillingBlowScreenFrameOverlay:SetEdgeColor(ZO_ColorDef:New(r, g, b, a):UnpackRGBA())
        end,
        disabled = function() return not DsRGuildPvP.pvp.PvPKillenableFrame end
    },
    {
        type = "header",
        name = zo_iconFormat("/esoui/art/icons/icon_alliancepoints.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildPvP_alliancepointsmsg)
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_AP.dds", 26, 26) .. GetString(DsRGuildPvP_alliancepoints),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAP end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAP = val end,
        width    = "half"
    },
    {
        type        = 'editbox',
        name        = GetString(DsRGuildPvP_ap_gain),
        getFunc     = function() return DsRGuildPvP.pvp.PvPAPvalue end,
        setFunc     = function(value) DsRGuildPvP.pvp.PvPAPvalue = value end,
        isMultiline = false,
        width       = "half",
        disabled    = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/vendor/vendor_tabicon_repair_down.dds", 26, 26) .. GetString(DsRGuildPvP_ap_repair),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPrep end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPrep = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/deathrecap/deathrecap_killingblow_icon.dds", 28, 28) .. GetString(DsRGuildPvP_ap_kills),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPdeath end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPdeath = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_offensechat),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPoffenschat end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPoffenschat = val end,
        width    = "half",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_offensescreen),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPoffensscreen end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPoffensscreen = val end,
        width    = "half",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_defensechat),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPdeffenschat end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPdeffenschat = val end,
        width    = "half",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_defensescreen),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPdeffensscreen end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPdeffensscreen = val end,
        width    = "half",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_revival),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPressurect end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPressurect = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildPvP_ap_awards),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPmedal end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPmedal = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/worldmap/map_indexicon_quests_down.dds", 26, 26) .. GetString(DsRGuildPvP_ap_quest),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPquest end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPquest = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/battlegrounds/battlegrounds_tabicon_battlegrounds_down.dds", 26, 26) .. GetString(DsRGuildPvP_ap_battleground),
        getFunc  = function() return DsRGuildPvP.pvp.PvPAPmatch end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPAPmatch = val end,
        width    = "full",
        disabled = function() return not DsRGuildPvP.pvp.PvPAP end
    },
    {
        type = "header",
        name = zo_iconFormat("/esoui/art/icons/icon_telvarstone.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildPvP_ap_telvarmsg)
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/icon_telvarstone.dds", 26, 26) .. GetString(DsRGuildPvP_ap_telvar),
        getFunc  = function() return DsRGuildPvP.pvp.PvPTelVar end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPTelVar = val end,
        width    = "full"
    },
    {
        type     = "slider",
        name        = GetString(DsRGuildPvP_ap_telvarSaver),
        tooltip     = GetString(DsRGuildPvP_ap_telvarSaverTP),
        autoSelect  = true,
        clampInput  = true,
        decimals    = 0,
        step        = 100,
        min         = 0,
        max         = 50000,
        default     = 0,
        getFunc     = function() return DsRGuildPvP.pvp.PvPTelVarSaver end,
        setFunc     = function(val) DsRGuildPvP.pvp.PvPTelVarSaver = val end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvP_ap_telvarSaverGroup),
        tooltip  = GetString(DsRGuildPvP_ap_telvarSaverGroupTP),
        getFunc  = function() return DsRGuildPvP.pvp.PvPTelVarSaverQAsGroup end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPTelVarSaverQAsGroup = val end,
        width    = "full",	
        disabled = function() return (DsRGuildPvP.pvp.PvPTelVarSaver == 0) end
    },
    {
        type = "header",
        name = zo_iconFormat("/esoui/art/icons/battleground_medal_killingblow_007.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildMenue_cyrodiilqueue)
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildMenue_cyrodiilqueueenable),
        getFunc = function() return DsRGuildPvP.pvp.enableQueueBar end,
        setFunc = function(val) 
            DsRGuildPvP.pvp.enableQueueBar = val
            DsRGuildPvPscore.ScoreWindow_Update()
        end
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildMenue_statsBarLocked) .. zo_iconFormat("/esoui/art/progression/progression_crafting_locked_up.dds", 26, 26),
        tooltip = GetString(DsRGuildMenue_statsBarLockedTP),
        getFunc = function() return DsRGuildPvP.pvp.statsBarLocked end,
        setFunc = function(val) 
            DsRGuildPvP.pvp.statsBarLocked = val
            DsRScoreWindow:SetMovable(not(DsRGuildPvP.pvp.statsBarLocked))
        end,
        disabled = function() return not DsRGuildPvP.pvp.enableQueueBar end
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildMenue_hideInPvE),
        tooltip = GetString(DsRGuildMenue_hideInPvETP),
        getFunc = function() return DsRGuildPvP.pvp.hideInPvE end,
        setFunc = function(val) 
            DsRGuildPvP.pvp.hideInPvE = val 
            DsRGuildPvPscore.ScoreWindow_Update()
        end,
        disabled = function() return not DsRGuildPvP.pvp.enableQueueBar end
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildMenue_scoreWindowScale),
        tooltip = GetString(DsRGuildMenue_scoreWindowScaleTP),
        min     = -40,
        max     = 40,
        getFunc = function() 
            return DsRGuildPvP.pvp.scoreWindowScale
        end,
        setFunc = function(val)
            DsRGuildPvP.pvp.scoreWindowScale = val
            DsRGuildPvPscore.ScoreWindow_Scale()
        end,
        disabled = function() return not DsRGuildPvP.pvp.enableQueueBar end
    },
    {
        type = "header",
        name = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_CastleDoor.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildMenue_cyrodiildoor)
    },
    {
        type    = "colorpicker",
        name    = GetString(DsRGuildMenue_cyrodiildoorpintint),
        tooltip = GetString(DsRGuildMenue_cyrodiildoorpintintTP),
        requiresReload = true,
        getFunc = function()
            return DsRMenu.GetRGBColor(DsRGuildPvP.pvp.PvPdoorPinRGB)
        end,
        setFunc = function(r, g, b)
            DsRGuildPvP.pvp.PvPdoorPinRGB = {["r"] = r, ["g"] = g, ["b"] = b}
            LMP:RefreshPins(DsR_PinsDoor)
        end,
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildMenue_cyrodiildoorpintsize),
        tooltip = GetString(DsRGuildMenue_cyrodiildoorpintsizeTP),
        requiresReload = true,
        min     = 20,
        max     = 70,
        step    = 1,
        getFunc = function()
            return  DsRGuildPvP.pvp.PvPdoorPinSize
        end,
        setFunc = function(val)
            DsRGuildPvP.pvp.PvPdoorPinSize = val
            LMP:SetLayoutKey(DsR_PinsDoor, "size", val)
            LMP:RefreshPins(DsR_PinsDoor)
        end,
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildMenue_cyrodiildoorpintlayer),
        tooltip = GetString(DsRGuildMenue_cyrodiildoorpintlayerTP),
        requiresReload = true,
        min     = 1,
        max     = 300,
        step    = 5,
        getFunc = function()
            return  DsRGuildPvP.pvp.PvPdoorPinLevel
        end,
        setFunc = function(val)
            DsRGuildPvP.pvp.PvPdoorPinLevel = val
            LMP:SetLayoutKey(DsR_PinsDoor, "level", val)
            LMP:RefreshPins(DsR_PinsDoor)
        end,
    },
    {
        type = "header",
        name = zo_iconFormat("/esoui/art/compass/ava_imperialcity_neutral.dds", 28, 28) .. "|cFAA0A0" .. GetString(DsRGuildMenue_ImperialCity),
    },
    {
        type    = "checkbox",
        name    = GetString(DsRGuildMenue_ImperialCityDistrict),
        tooltip = GetString(DsRGuildMenue_ImperialCityDistrictTP),
        getFunc = function() 
            return DsRGuildPvP.pvp.PvPdoorImperial
        end,
        setFunc = function(val) 
            DsRGuildPvP.pvp.PvPdoorImperial = val
            if not val then
                local impData = DsRGuildPvPdoorPins_GetImperialData() 
                for _, data in ipairs(impData) do
                    LMP:RemoveCustomPin(data.label)
                end
            end
            LMP:RefreshPins(DsR_PinsDoor)
        end
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- PvP Status
-------------------------------------------------------------------------------------------------------------------------------------------------
local PvPstatus = {
    {
        type    = "checkbox",
        name    = GetString(DsRGuildPvPstatus_enabled),
        getFunc = DsRMenu.GetCsEnabled,
        setFunc = DsRMenu.SetCsEnabled
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_positionfixed) .. zo_iconFormat("/esoui/art/progression/progression_crafting_locked_up.dds", 26, 26),
        getFunc  = DsRMenu.GetCsPositionLocked,
        setFunc  = DsRMenu.SetCsPositionLocked
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_showBGtransparent),
        getFunc  = function() return DsRGuildPvP.pvp.PvPstatusshowBackground end,
        setFunc  = function(val) DsRGuildPvP.pvp.PvPstatusshowBackground = val end,
        width = "full"
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_hideworldmap),
        getFunc  = DsRMenu.GetCsHideOnWorldMap,
        setFunc  = DsRMenu.SetCsHideOnWorldMap
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_showflags) .. zo_iconFormat("/esoui/art/compass/ava_flagneutral.dds", 26, 26),
        getFunc  = DsRMenu.GetCsShowFlagsEnabled,
        setFunc  = DsRMenu.SetCsShowFlagsEnabled
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_showsieges) .. zo_iconFormat("/esoui/art/compass/compass_bg_flagattack_pin.dds", 26, 26),
        getFunc  = DsRMenu.GetCsShowSiegesEnabled,
        setFunc  = DsRMenu.SetCsShowSiegesEnabled
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_showownerchanges),
        getFunc  = DsRMenu.GetCsShowOwnerChangesEnabled,
        setFunc  = DsRMenu.SetCsShowOwnerChangesEnabled
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildPvPstatus_showactiontimers),
        getFunc  = DsRMenu.GetCsShowActionTimersEnabled,
        setFunc  = DsRMenu.SetCsShowActionTimersEnabled
    },
    {
        type     = "colorpicker",
        name     = GetString(DsRGuildPvPstatus_colordefault),
        getFunc  = DsRMenu.GetCsDefaultColor,
        setFunc  = DsRMenu.SetCsDefaultColor,
        width    = "full"
    },
    {
        type     = "colorpicker",
        name     = GetString(DsRGuildPvPstatus_colorcooldown),
        getFunc  = DsRMenu.GetCsCooldownColor,
        setFunc  = DsRMenu.SetCsCooldownColor,
        width    = "full"
    },
    {
        type     = "colorpicker",
        name     = GetString(DsRGuildPvPstatus_colorflipspositive),
        getFunc  = DsRMenu.GetCsFlipsAtPositiveColor,
        setFunc  = DsRMenu.SetCsFlipsAtPositiveColor,
        width    = "full"
    },
    {
        type     = "colorpicker",
        name     = GetString(DsRGuildPvPstatus_colorflipsnegative),
        getFunc  = DsRMenu.GetCsFlipsAtNegativeColor,
        setFunc  = DsRMenu.SetCsFlipsAtNegativeColor,
        width    = "full"
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/compass/ava_largekeep_neutral.dds", 26, 26) .. GetString(DsRGuildPvPstatus_showkeeps),
        getFunc  = DsRMenu.GetCsShowKeeps,
        setFunc  = DsRMenu.SetCsShowKeeps
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/compass/ava_outpost_neutral.dds", 26, 26) .. GetString(DsRGuildPvPstatus_showoutposts),
        getFunc  = DsRMenu.GetCsShowOutposts,
        setFunc  = DsRMenu.SetCsShowOutposts
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/mappins/ava_lumbermill_neutral.dds", 28, 28) .. GetString(DsRGuildPvPstatus_showresources),
        getFunc  = DsRMenu.GetCsShowResources,
        setFunc  = DsRMenu.SetCsShowResources
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/compass/ava_town_neutral.dds", 26, 26) .. GetString(DsRGuildPvPstatus_showvillages),
        getFunc  = DsRMenu.GetCsShowVillages,
        setFunc  = DsRMenu.SetCsShowVillages
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/compass/ava_artifacttemple_ebonheart.dds", 26, 26) .. GetString(DsRGuildPvPstatus_showtemples),
        getFunc  = DsRMenu.GetCsShowTemples,
        setFunc  = DsRMenu.SetCsShowTemples
    },
    {
        type     = "checkbox",
        name     = zo_iconFormat("/esoui/art/mappins/ava_milegate_passable.dds", 28, 28) .. GetString(DsRGuildPvPstatus_showdestructibles),
        getFunc  = DsRMenu.GetCsShowDestructibles,
        setFunc  = DsRMenu.SetCsShowDestructibles
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- PvP Boss Timer
-------------------------------------------------------------------------------------------------------------------------------------------------
local PvPbosstimer = {
    {
        type = "checkbox",
        name = GetString(DsRPvPBossTimer_OPTION_TIMETABLE),
        getFunc = function() return DsRGuildPvP.pvp.PvPtimetable end,
        setFunc = function(value)
                    DsRGuildPvP.pvp.PvPtimetable = value
                    if value == true then
                        HUD_SCENE:AddFragment(DsRPvPBossTimer.ui.timetable)
                        HUD_UI_SCENE:AddFragment(DsRPvPBossTimer.ui.timetable)
                        DsRPvPBossTimerTimeTable:SetHidden(false)
                    else
                        DsRPvPBossTimerTimeTable:SetHidden(true)
                        HUD_SCENE:RemoveFragment(DsRPvPBossTimer.ui.timetable)
                        HUD_UI_SCENE:RemoveFragment(DsRPvPBossTimer.ui.timetable)
                    end
                  end,
        width = "full"
    },
    {
        type = "checkbox",
        name = GetString(DsRPvPBossTimer_OPTION_MAPTIMERS),
        tooltip = GetString(DsRPvPBossTimer_OPTION_MAPTIMERS_TOOLTIP),
        getFunc = function() return DsRGuildPvP.pvp.PvPmaptimers end,
        setFunc = function(value) DsRGuildPvP.pvp.PvPmaptimers = value end,
        width = "full",
    },
    {
        type = "checkbox",
        name = GetString(DsRPvPBossTimer_OPTION_EVENT_TIMERS),
        getFunc = function() return DsRGuildPvP.pvp.PvPeventtimers end,
        setFunc = function(value) 
            DsRGuildPvP.pvp.PvPeventtimers = value
            DsRPvPBossTimer.editSpawnTime()
        end,
        width = "full",
    },
    {
        type = "checkbox",
        name = GetString(DsRPvPBossTimer_OPTION_RUN_DIRECTION),
        getFunc = function() return DsRGuildPvP.pvp.PvPccw_cw end,
        setFunc = function(value) 
            DsRGuildPvP.pvp.PvPccw_cw = value
        end,
        width = "full",
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Beams
-------------------------------------------------------------------------------------------------------------------------------------------------
local groupbeams = {
    {
        type 	 = "description",
        text     = GetString(DsRGuildMenue_BeamAttention)
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightEnabled),
        tooltip  = GetString(DsRGuildBeam_LightEnabledTP),
        key      = "LightEnabled",
        default  = false,
        disabled = function() return false end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightCombatOnly),
        tooltip  = GetString(DsRGuildBeam_LightCombatOnly),
        key      = "LightCombatOnly",
        default  = false,
        disabled = function() return false end
    },
    {
        type       = "slider",
        name       = GetString(DsRGuildBeam_LightAlpha),
        tooltip    = GetString(DsRGuildBeam_LightAlphaTP),
        autoSelect = true,
        clampInput = true,
        decimals   = 0,
        step       = 5,
        min        = 10,
        max        = 150,
        key        = "LightAlpha",
        lomDefault = 0.5,
        default    = 100,
        getFunc    = function() return 100 * ( DsRGuildBeam.GetSetting( "LightAlpha" ) or 0.5 ) end,
        setFunc    = function(value) DsRGuildBeam.SetSetting( "LightAlpha", value / 100 ) end,
        disabled   = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type        = "slider",
        name        = GetString(DsRGuildBeam_LightScale),
        tooltip     = GetString(DsRGuildBeam_LightScaleTP),
        autoSelect  = true,
        clampInput  = true,
        decimals    = 0,
        step        = 5,
        min         = 10,
        max         = 150,
        key         = "LightScale",
        lomDefault  = 0.75,
        default     = 50,
        getFunc     = function() return 100 * ( DsRGuildBeam.GetSetting( "LightScale" ) or 1 ) end,
        setFunc     = function(value) DsRGuildBeam.SetSetting( "LightScale", value / 100 ) end,
        disabled    = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type      = "checkbox",
        name      = GetString(DsRGuildBeam_LightAlwaysIgnoresDepthBuffer),
        tooltip   = GetString(DsRGuildBeam_LightAlwaysIgnoresDepthBufferTP),
        key       = "LightAlwaysIgnoresDepthBuffer",
        onChange  = DsRGuildBeam.EffectUIUpdateObstaclePenetration,
        default   = false,
        disabled  = function() return false end,
        reference = "DsRLightAlwaysIgnoresDepthBuffer"
    },
    {
        type = "custom",
    },
    {
        type = "header",
        name = GetString(DsRGuildBeam_HeaderTWO)
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightDead),
        tooltip  = GetString(DsRGuildBeam_LightDeadTP),
        key      = "LightDead",
        default  = true,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "full",
        key      = "LightDeadColor",
        default  = { r = 1, g = 0, b = 0 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "LightDeadColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "LightDeadColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightDead" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightResurrecting),
        tooltip  = GetString(DsRGuildBeam_LightResurrectingTP),
        key      = "LightResurrecting",
        default  = true,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightDead" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "full",
        key      = "LightResurrectingColor",
        default  = { r = 0.9, g = 1, b = 0 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "LightResurrectingColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "LightResurrectingColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightResurrecting" ) end
    },
    {
        type = "custom",
    },
    {
        type = "header",
        name = GetString(DsRGuildBeam_HeaderTHREE)
    },
    {
        type = "description",
        text = GetString(DsRGuildBeam_HeaderTHREEdesc)
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_HighlightLeader),
        tooltip  = GetString(DsRGuildBeam_HighlightLeaderTP),
        key      = "HighlightLeader",
        default  = true,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "full",
        key      = "HighlightLeaderColor",
        default  = { r = 1, g = 1, b = 1 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "HighlightLeaderColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "HighlightLeaderColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "HighlightLeader" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_HighlightTanks),
        tooltip  = GetString(DsRGuildBeam_HighlightTanksTP),
        key      = "HighlightTanks",
        default  = false,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "full",
        key      = "HighlightTanksColor",
        default  = { r = 0, g = 1, b = 0 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "HighlightTanksColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "HighlightTanksColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "HighlightTanks" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_HighlightHealers),
        tooltip  = GetString(DsRGuildBeam_HighlightHealersTP),
        key      = "HighlightHealers",
        default  = false,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "full",
        key      = "HighlightHealersColor",
        default  = { r = 0, g = 0, b = 1 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "HighlightHealersColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "HighlightHealersColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "HighlightHealers" ) end
    },
    {
        type = "custom",
    },
    {
        type = "header",
        name = GetString(DsRGuildBeam_HeaderFOUR)
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightGroupMembers),
        tooltip  = GetString(DsRGuildBeam_LightGroupMembersTP),
        key      = "LightGroupMembers",
        default  = true,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightBattlegroundTeam),
        tooltip  = GetString(DsRGuildBeam_LightBattlegroundTeamTP),
        key      = "LightBattlegroundTeam",
        default  = true,
        width    = "half",
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "half",
        key      = "LightBattlegroundTeamColor",
        default  = { r = 0.2, g = 1, b = 1 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "LightBattlegroundTeamColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "LightBattlegroundTeamColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) or not DsRGuildBeam.GetSetting( "LightBattlegroundTeam" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightCyrodiilTeam),
        tooltip  = GetString(DsRGuildBeam_LightCyrodiilTeamTP),
        key      = "LightCyrodiilTeam",
        default  = true,
        width    = "half",
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "half",
        key      = "LightCyrodiilTeamColor",
        default  = { r = 0.2, g = 1, b = 1 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "LightCyrodiilTeamColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "LightCyrodiilTeamColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) or not DsRGuildBeam.GetSetting( "LightCyrodiilTeam" ) end
    },
    {
        type     = "checkbox",
        name     = GetString(DsRGuildBeam_LightNonPVPTeam),
        tooltip  = GetString(DsRGuildBeam_LightNonPVPTeamTP),
        key      = "LightNonPVPTeam",
        default  = true,
        width    = "half",
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) end
    },
    {
        type     = "colorpicker",
        name     = "Color",
        width    = "half",
        key      = "LightNonPVPTeamColor",
        default  = { r = 0.2, g = 1, b = 1 },
        getFunc  = function() local c = DsRGuildBeam.GetColorSetting( "LightNonPVPTeamColor" ) if c then return c.r, c.g, c.b end end,
        setFunc  = function( vr, vg, vb, va ) DsRGuildBeam.SetColorSetting( "LightNonPVPTeamColor", { r = vr, g = vg, b = vb } ) end,
        disabled = function() return not DsRGuildBeam.GetSetting( "LightEnabled" ) or not DsRGuildBeam.GetSetting( "LightGroupMembers" ) or not DsRGuildBeam.GetSetting( "LightNonPVPTeam" ) end
    },
}
-------------------------------------------------------------------------------------------------------------------------------------------------
-- Achievement Tracker
-------------------------------------------------------------------------------------------------------------------------------------------------
local achievtracker = {
    {
        type 	 = "description",
        text     = GetString(DsRGuildAchievTracker_Desc)
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_OnOff),
        requiresReload = true,
        getFunc  = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.AchievTrackOnOff = val
        end,
        width    = "full"
    },
    {
        type 	 = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_Lock) .. zo_iconFormat("/esoui/art/progression/progression_crafting_locked_up.dds", 26, 26),
        tooltip  = GetString(DsRGuildAchievTracker_LockTP),
        getFunc  = function() return DsRGuildAchievTracker.config.locked end,
        setFunc  = function(val) 
            DsRGuildAchievTracker.config.locked = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_ShowIcons),
        tooltip  = GetString(DsRGuildAchievTracker_ShowIconsTP),
        getFunc  = function() return DsRGuildAchievTracker.config.showIcons end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.showIcons = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_ShowDesc),
        tooltip  = GetString(DsRGuildAchievTracker_ShowDescTP),
        getFunc  = function() return DsRGuildAchievTracker.config.showDesc end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.showDesc = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_autoTrackZoneAchievements),
        tooltip  = GetString(DsRGuildAchievTracker_autoTrackZoneAchievementsTP),
        getFunc  = function() return DsRGuildAchievTracker.config.autoTrackZoneAchievements end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.autoTrackZoneAchievements = val
            DsRGuildAchievTracker.lastZone = nil
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_hideOldZoneAchievements),
        tooltip  = GetString(DsRGuildAchievTracker_hideOldZoneAchievementsTP),
        getFunc  = function() return DsRGuildAchievTracker.config.hideOldZoneAchievements end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.hideOldZoneAchievements = val
            DsRGuildAchievTracker.lastZone = nil
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_showTrackedAchievementCount),
        tooltip  = GetString(DsRGuildAchievTracker_showTrackedAchievementCountTP),
        requiresReload = true,
        getFunc  = function() return DsRGuildAchievTracker.config.showTrackedAchievementCount end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.showTrackedAchievementCount = val
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildAchievTracker_hideCompleted),
        tooltip  = GetString(DsRGuildAchievTracker_hideCompletedTP),
        getFunc  = function() return DsRGuildAchievTracker.config.hideCompleted end,
        setFunc  = function(val)
            DsRGuildAchievTracker.config.hideCompleted = val
            DsRGuildAchievTracker.lastZone = nil
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        width    = "full",
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildAchievTracker_bgAlpha),
        tooltip = GetString(DsRGuildAchievTracker_bgAlphaTP),
        min     = 0,
        max     = 100,
        step    = 1,
        width   = full,
        getFunc = function() return DsRGuildAchievTracker.config.bgAlpha end,
        setFunc = function(val)
            DsRGuildAchievTracker.config.bgAlpha = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildAchievTracker_maxTracked),
        tooltip = GetString(DsRGuildAchievTracker_maxTrackedTP),
        min     = 0,
        max     = 10,
        step    = 1,
        width   = full,
        getFunc = function() return DsRGuildAchievTracker.config.maxTracked end,
        setFunc = function(val)
            DsRGuildAchievTracker.config.maxTracked = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildAchievTracker_fontSizeName),
        tooltip = GetString(DsRGuildAchievTracker_fontSizeNameTP),
        min     = 8,
        max     = 30,
        step    = 1,
        width   = full,
        getFunc = function() return DsRGuildAchievTracker.config.fontSizename end,
        setFunc = function(val)
            DsRGuildAchievTracker.config.fontSizename = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type    = "slider",
        name    = GetString(DsRGuildAchievTracker_fontSizeDesc),
        tooltip = GetString(DsRGuildAchievTracker_fontSizeDescTP),
        min     = 8,
        max     = 30,
        step    = 1,
        width   = full,
        getFunc = function() return DsRGuildAchievTracker.config.fontSizedesc end,
        setFunc = function(val)
            DsRGuildAchievTracker.config.fontSizedesc = val
            DsRGuildAchievTracker:LoadTrackedAchievements()
        end,
        disabled = function() return DsRGuildAchievTracker.config.AchievTrackOnOff end
    },
    {
        type 	 = "button",
        name     = GetString(DsRGuildAchievTracker_reset),
        tooltip  = GetString(DsRGuildAchievTracker_resetTP),
        func     = function() DsRGuildAchievTracker:Reset() end,
        width    = "half"
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- XP / EP / Food Buff Reminder
-------------------------------------------------------------------------------------------------------------------------------------------------
local buffreminder = {
    {
        type 	 = "description",
        text     = GetString(DsRGuildReminder_Interval)
    },
    {
        type = "divider",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/justice_stolen_food_001.dds", 26, 26) ..GetString(DsRGuildReminder_BuffFoodONOff),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderfoodOnOff end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderfoodOnOff = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildReminder_BuffFoodfalse),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderfoodfalse end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderfoodfalse = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderfoodOnOff end
    },
    {
        type 	 = "dropdown",
        name 	 = GetString(DsRGuildReminder_BuffFoodMinTime),
        choices  = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"},
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderBuffFoodMinTime end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderBuffFoodMinTime = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderfoodOnOff end
    },
    {
        type = "custom",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_XP.dds", 26, 26) .. GetString(DsRGuildReminder_XPONOff),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderxpOnOff end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderxpOnOff = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildReminder_XPfalse),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderxpfalse end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderxpfalse = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderxpOnOff end
    },
    {
        type 	 = "dropdown",
        name 	 = GetString(DsRGuildReminder_XPMinTime),
        choices  = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"},
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderxpMinTime end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderxpMinTime = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderxpOnOff end
    },
    {
        type = "custom",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/DsRGuildHall/misc/DsR/DsR_AP.dds", 26, 26) .. GetString(DsRGuildReminder_APONOff),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderapOnOff end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderapOnOff = val end,
        width    = "full"
    },
    {
        type 	 = "checkbox",
        name 	 = GetString(DsRGuildReminder_APfalse),
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderapfalse end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderapfalse = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderapOnOff end
    },
    {
        type 	 = "dropdown",
        name 	 = GetString(DsRGuildReminder_APMinTime),
        choices  = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"},
        getFunc  = function() return DsRGuildLoot.sV.DsRReminderapMinTime end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRReminderapMinTime = val end,
        width    = "full",
        disabled = function() return not DsRGuildLoot.sV.DsRReminderapOnOff end
    },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Daily Crafter / Precarfter
-------------------------------------------------------------------------------------------------------------------------------------------------
local dailycrafter = {
    {
        type = "header",
        name = GetString(DsRGuildCrafting_PrecraftHeader)
    },
    {
        type 	 = "description",
        text     = GetString(DsRGuildCrafting_PrecraftDESC)
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_blacksmithing.dds", 26, 26) .. GetString(DsRGuildLoot_exp_blacksmithing),
        getFunc  = function() return DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftBlacksmithing end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftBlacksmithing = val end,
        width    = "full",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_clothier.dds", 26, 26) .. GetString(DsRGuildLoot_exp_clothier),
        getFunc  = function() return DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftClothier end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftClothier = val end,
        width    = "full",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_woodworking.dds", 26, 26) .. GetString(DsRGuildLoot_exp_woodworking),
        getFunc  = function() return DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftWoodworking end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftWoodworking = val end,
        width    = "full",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_jewelrymaking.dds", 26, 26) .. GetString(DsRGuildLoot_exp_jewelrymaking),
        getFunc  = function() return DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftJewelry end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftJewelry = val end,
        width    = "full",
    },
    {
        type 	 = "checkbox",
        name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_enchanting.dds", 26, 26) .. GetString(DsRGuildLoot_exp_enchanting),
        getFunc  = function() return DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftEnchanting end,
        setFunc  = function(val) DsRGuildLoot.sV.DsRPrecraftprofessions.DsRPrecraftEnchanting = val end,
        width    = "full",
    },
    -- {
    --     type = "header",
    --     name = GetString(DsRGuildCrafting_DailyHeader)
    -- },
    -- {
    --     type 	 = "checkbox",
    --     name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_alchemy.dds", 26, 26) .. GetString(DsRGuildCrafting_Alchemy),
    --     getFunc  = function() return DsRGuildLoot.sV.DsRDailyCraftAlchemy end,
    --     setFunc  = function(val)
    --         DsRGuildAchievTracker.config.DsRDailyCraftAlchemy = val
    --     end,
    --     width    = "full"
    -- },
    -- {
    --     type 	 = "checkbox",
    --     name 	 = zo_iconFormat("/esoui/art/icons/skilllinexp_provisioner.dds", 26, 26) .. GetString(DsRGuildCrafting_Provision),
    --     getFunc  = function() return DsRGuildLoot.sV.DsRDailyCraftProvision end,
    --     setFunc  = function(val)
    --         DsRGuildAchievTracker.config.DsRDailyCraftProvision = val
    --     end,
    --     width    = "full"
    -- },
}

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Base Menue Settings
-------------------------------------------------------------------------------------------------------------------------------------------------
local optionsData = {}

	table.insert(optionsData, {
		type = "description",
		text = GetString(DsRGuildMenue_accsettings)
	})
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/chatwindow/chat_notification_up.dds", 26, 26) .. GetString(DsRGuildMenue_chatcommands),
        controls = Chatcommands
    })
	table.insert(optionsData, {
		type = "header",
		name = zo_iconFormat("/esoui/art/hud/loothistory_bonusdropsourceicon_expscroll.dds", 28, 28) .. "|c7393B3" .. GetString(DsRGuildMenue_lootmanager) .."|r"
	})
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/help/help_tabicon_tutorial_up.dds", 26, 26) .. GetString(DsRGuildMenue_notificationscreen),
        controls = LootManagerScreen
    })
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/help/help_tabicon_tutorial_up.dds", 26, 26) .. GetString(DsRGuildMenue_notificationchat),
        controls = LootManagerChat
    })
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/DsRGuildHall/misc/DsR/tradehammer.dds", 26, 26) .. GetString(DsRGuildMenue_trading),
        controls = LootManagerTrading
    })
	table.insert(optionsData,{
        type = "submenu",
        name = "|cb81414|t28:28:/esoui/art/collections/collections_tabicon_itemsets_down.dds:inheritcolor|t|r".. GetString(DsRGuildMenue_stickerbook),
        controls = StickerBind
    })
	table.insert(optionsData, {
		type = "header",
		name = zo_iconFormat("/esoui/art/guild/ownership_icon_keep.dds", 26, 26) .. "|cFAA0A0" .. GetString(DsRGuildMenue_alliancewar) .."|r" 
	})
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/icons/icon_alliancepoints.dds", 26, 26) .. GetString(DsRGuildMenue_cyrodiil) .. " & " .. zo_iconFormat("/esoui/art/icons/icon_telvarstone.dds", 26, 26) .. GetString(DsRGuildMenue_ImperialCity),
        controls = PvPWar
    })
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/mappins/ava_3way.dds", 26, 26) .. GetString(DsRGuildMenue_cyrostatus),
        controls = PvPstatus
    })
    table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/lfg/lfg_indexicon_imperialcity_up.dds", 26, 26) .. GetString(DsRPvPBossTimer_Menue),
        controls = PvPbosstimer
    })
    table.insert(optionsData, {
		type = "header",
		name = "|cFFBF00" .. GetString(DsRGuildMenue_Divers)  .."|r"
	})
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/crafting/burst_gold.dds", 26, 26) .. GetString(DsRGuildMenue_beams),
        controls = groupbeams
    })
	table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/icons/u40_dibellas_delights.dds", 26, 26) .. GetString(DsRGuildMenue_BuffReminder),
        controls = buffreminder
    })
    table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/tutorial/journal_tabicon_achievements_up.dds", 26, 26) .. GetString(DsRGuildAchievTracker_SubMenu),
        controls = achievtracker
    })
    table.insert(optionsData,{
        type = "submenu",
        name = zo_iconFormat("/esoui/art/charactercreate/charactercreate_raceicon_disabled.dds", 26, 26) .. GetString(DsRGuildCrafting_SubMenu),
        controls = dailycrafter
    })


	for index, opt in ipairs( groupbeams ) do
		if "string" == type( opt.key ) then
			if nil ~= opt.default then
				DsRGuildBeam.SetDefaultSetting( opt.key, nil ~= opt.lomDefault and opt.lomDefault or opt.default )
			end

			if not opt.getFunc then
				opt.getFunc = function()
					return DsRGuildBeam.GetSetting( opt.key )
				end
			end

			if not opt.setFunc then
				opt.setFunc = function(value)
					DsRGuildBeam.SetSetting( opt.key, value )

					if opt.onChange then
						opt.onChange(value)
					end
				end
			end
		end
	end

	LAM:RegisterAddonPanel("DsRGuildHall", panelData)
	LAM:RegisterOptionControls("DsRGuildHall", optionsData)
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Function
-------------------------------------------------------------------------------------------------------------------------------------------------

function DsRMenu.GetCsEnabled()
	return DsRGuildPvP.pvp.PvPstatusenabled
end

function DsRMenu.SetCsEnabled(value)
	DsRGuildPvPstatus.SetEnabled(value)
end

function DsRMenu.GetCsPositionLocked()
	return DsRGuildPvP.pvp.PvPstatuspositionLocked
end

function DsRMenu.SetCsPositionLocked(value)
	DsRGuildPvPstatus.SetPositionLocked(value)
end

function DsRMenu.GetCsHideOnWorldMap()
	return DsRGuildPvP.pvp.PvPstatushideOnWorldMap
end

function DsRMenu.SetCsHideOnWorldMap(value)
	DsRGuildPvP.pvp.PvPstatushideOnWorldMap = value
end

function DsRMenu.GetCsShowFlagsEnabled()
	return DsRGuildPvP.pvp.PvPstatusshowFlags
end

function DsRMenu.SetCsShowFlagsEnabled(value)
	DsRGuildPvP.pvp.PvPstatusshowFlags = value
	DsRGuildPvPstatus.AdjustDisplayedComponents()
end

function DsRMenu.GetCsShowSiegesEnabled()
	return DsRGuildPvP.pvp.PvPstatusshowSieges
end

function DsRMenu.SetCsShowSiegesEnabled(value)
	DsRGuildPvP.pvp.PvPstatusshowSieges = value
	DsRGuildPvPstatus.AdjustDisplayedComponents()
end

function DsRMenu.GetCsShowOwnerChangesEnabled()
	return DsRGuildPvP.pvp.PvPstatusshowOwnerChanges
end

function DsRMenu.SetCsShowOwnerChangesEnabled(value)
	DsRGuildPvP.pvp.PvPstatusshowOwnerChanges = value
	DsRGuildPvPstatus.AdjustDisplayedComponents()
end

function DsRMenu.GetCsShowActionTimersEnabled()
	return DsRGuildPvP.pvp.PvPstatusshowActionTimers
end

function DsRMenu.SetCsShowActionTimersEnabled(value)
	DsRGuildPvP.pvp.PvPstatusshowActionTimers = value
	DsRGuildPvPstatus.AdjustDisplayedComponents()
end

function DsRMenu.GetCsDefaultColor()
	return DsRMenu.GetRGBColor(DsRGuildPvP.pvp.PvPstatusdefaultColor)
end

function DsRMenu.SetCsDefaultColor(r, g, b)
	DsRGuildPvP.pvp.PvPstatusdefaultColor = DsRMenu.GetColorFromRGB(r, g, b)
end

function DsRMenu.GetCsCooldownColor()
	return DsRMenu.GetRGBColor(DsRGuildPvP.pvp.PvPstatuscooldownColor)
end

function DsRMenu.SetCsCooldownColor(r, g, b)
	DsRGuildPvP.pvp.PvPstatuscooldownColor = DsRMenu.GetColorFromRGB(r, g, b)
end

function DsRMenu.GetCsFlipsAtPositiveColor()
	return DsRMenu.GetRGBColor(DsRGuildPvP.pvp.PvPstatusflipsAtPositiveColor)
end

function DsRMenu.SetCsFlipsAtPositiveColor(r, g, b)
	DsRGuildPvP.pvp.PvPstatusflipsAtPositiveColor = DsRMenu.GetColorFromRGB(r, g, b)
end

function DsRMenu.GetCsFlipsAtNegativeColor()
	return DsRMenu.GetRGBColor(DsRGuildPvP.pvp.PvPstatusflipsAtNegativeColor)
end

function DsRMenu.SetCsFlipsAtNegativeColor(r, g, b)
	DsRGuildPvP.pvp.PvPstatusflipsAtNegativeColor = DsRMenu.GetColorFromRGB(r, g, b)
end

function DsRMenu.GetCsShowKeeps()
	return DsRGuildPvP.pvp.PvPstatusshowKeeps
end

function DsRMenu.SetCsShowKeeps(value)
	DsRGuildPvP.pvp.PvPstatusshowKeeps = value
end

function DsRMenu.GetCsShowOutposts()
	return DsRGuildPvP.pvp.PvPstatusshowOutposts
end

function DsRMenu.SetCsShowOutposts(value)
	DsRGuildPvP.pvp.PvPstatusshowOutposts = value
end

function DsRMenu.GetCsShowResources()
	return DsRGuildPvP.pvp.PvPstatusshowResources
end

function DsRMenu.SetCsShowResources(value)
	DsRGuildPvP.pvp.PvPstatusshowResources = value
end

function DsRMenu.GetCsShowVillages()
	return DsRGuildPvP.pvp.PvPstatusshowVillages
end

function DsRMenu.SetCsShowVillages(value)
	DsRGuildPvP.pvp.PvPstatusshowVillages = value
end

function DsRMenu.GetCsShowTemples()
	return DsRGuildPvP.pvp.PvPstatusshowTemples
end

function DsRMenu.SetCsShowTemples(value)
	DsRGuildPvP.pvp.PvPstatusshowTemples = value
end

function DsRMenu.GetCsShowDestructibles()
	return DsRGuildPvP.pvp.PvPstatusshowDestructibles
end

function DsRMenu.SetCsShowDestructibles(value)
	DsRGuildPvP.pvp.PvPstatusshowDestructibles = value
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Color function
-------------------------------------------------------------------------------------------------------------------------------------------------

function DsRMenu.GetRGBColor(color)
	return color.r, color.g, color.b
end

function DsRMenu.GetRGBAColor(color)
	return color.r, color.g, color.b, color.a
end

function DsRMenu.GetColorFromRGB(r, g, b)
	return {["r"] = r, ["g"] = g, ["b"] = b}
end

function DsRMenu.GetColorFromRGBA(r, g, b, a)
	return {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}
end
