-- Create namespace
DsRGuildPvP = {}
local DsRGuildPvP = DsRGuildPvP  or {}

DsRGuildPvP.name = "DsRGuildPvP"

local DsRlogger = ZO_Object:Subclass()
function DsRlogger:Info(...)end

DsRGuildPvP.queuedCampaignID = nil
DsRGuildPvP.queueState 		 = nil
DsRGuildPvP.queuePosition 	 = nil

local dsrPeriodic    = ZO_CallbackObject:Subclass()
DsRGuildPvP_Periodic = dsrPeriodic

DsRGuildPvP.queuePeriodic = DsRGuildPvP_Periodic:New()

-------------------------------------------------------------------------------------------------------------------------------------------------
-- AP update
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildPvP.OnAPUpdated(eventCode, alliancePoints, playSound, difference, reason, locationId)
	if reason == CURRENCY_CHANGE_REASON_PLAYER_INIT then return end

	if tonumber(difference) >= 0 then
		DsRGuildPvP.pvp.sessionStats.alliancePoints = DsRGuildPvP.pvp.sessionStats.alliancePoints + tonumber( difference )
		DsRGuildPvPscore.ScoreWindow_Update()
	end
	
	if not DsRGuildPvP.pvp.PvPAP then return end
	if tonumber(difference) < tonumber(DsRGuildPvP.pvp.PvPAPvalue) then return end

	local maxLevel = GetMaxLevel()
	local currentAvARank
	local rankProgAvA, rankMaxAvA
	local levelProgress
	local rankIcon

	local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_SMALL_TEXT)

	currentAvARank = GetUnitAvARank("player")
	local function GetCurrentRankProgress()
		local rankPoints = GetUnitAvARankPoints("player")
		local _, _, rankStartsAt, nextRankAt = GetAvARankProgress(rankPoints)
		if rankPoints >= nextRankAt then
			local lastRankPoints = GetNumPointsNeededForAvARank(currentAvARank - 1)
			local maxRankPoints = GetNumPointsNeededForAvARank(currentAvARank)
			local fullRankPoints = maxRankPoints - lastRankPoints

			return fullRankPoints, fullRankPoints
		else
			return rankPoints - rankStartsAt, nextRankAt - rankStartsAt
		end
	end
	rankProgAvA, rankMaxAvA = GetCurrentRankProgress()

	local APicon   = zo_iconTextFormat("/esoui/art/icons/icon_alliancepoints.dds", 18, 18, " ")
	local DsRicon  = zo_iconTextFormat("/DsRGuildHall/misc/DsR/DsR_AP.dds", 20, 20, " ")
	local DsRiconS = zo_iconTextFormat("/DsRGuildHall/misc/DsR/DsR_AP.dds", 30, 30, " ")

	rankIcon = GetAvARankIcon(GetUnitAvARank("player"))
	local lgIconText = zo_iconTextFormat(rankIcon, 18, 18, " ")

	local levelProgress = tostring(math.floor(100*(rankProgAvA/rankMaxAvA))).."%"
	local actualRP      = GetUnitAvARankPoints("player")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local GREENcolor	  = "|c35fc38"
	local darkGREENcolor  = "|c095e0a"
	
	if reason ~= CURRENCY_CHANGE_REASON_BANK_WITHDRAWAL and reason ~= CURRENCY_CHANGE_REASON_VENDOR then
		local LocationORI = zo_strformat("<<1>>", GetKeepName(locationId))
		local Location    = LocationORI:gsub("der ", ""):gsub("die ", ""):gsub("das ", "")

		if reason == CURRENCY_CHANGE_REASON_KEEP_REPAIR and DsRGuildPvP.pvp.PvPAPrep == true then -- 40
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_repairtxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP "  .. darkGREENcolor .. "[" .. Location .. "]    " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		elseif reason == CURRENCY_CHANGE_REASON_KILL and DsRGuildPvP.pvp.PvPAPdeath == true then -- 13
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_killstxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		elseif reason == CURRENCY_CHANGE_REASON_OFFENSIVE_KEEP_REWARD then -- 74	
			if DsRGuildPvP.pvp.PvPAPoffenschat == true then
				d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_offensetxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP "  .. darkGREENcolor .. "[" .. Location .. "]    " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " ..  ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			end
			if DsRGuildPvP.pvp.PvPAPoffensscreen == true then
				params:SetText(DsRiconS .. GREENcolor .. GetString(DsRGuildPvP_ap_offensetxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP "  .. darkGREENcolor .. "[" .. Location .. "]")
				CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
			end
			return
		elseif reason == CURRENCY_CHANGE_REASON_DEFENSIVE_KEEP_REWARD then -- 75
			if DsRGuildPvP.pvp.PvPAPdeffenschat == true then
				d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_defensetxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP "  .. darkGREENcolor .. "[" .. Location .. "]    " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " ..  ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			end
			if DsRGuildPvP.pvp.PvPAPdeffensscreen == true then
				params:SetText(DsRiconS .. GREENcolor .. GetString(DsRGuildPvP_ap_defensetxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP "  .. darkGREENcolor .. "[" .. Location .. "]")
				CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
			end
			return
		elseif reason == CURRENCY_CHANGE_REASON_PVP_RESURRECT and DsRGuildPvP.pvp.PvPAPressurect == true then -- 41
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_revivaltxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		elseif reason == CURRENCY_CHANGE_REASON_MEDAL and DsRGuildPvP.pvp.PvPAPmedal == true then -- 21
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_awardstxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		elseif reason == CURRENCY_CHANGE_REASON_BATTLEGROUND and DsRGuildPvP.pvp.PvPAPmatch == true then -- 12
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_battlegroundtxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		elseif ( reason == CURRENCY_CHANGE_REASON_TRADE or reason == CURRENCY_CHANGE_REASON_QUESTREWARD ) and DsRGuildPvP.pvp.PvPAPquest == true then -- 3 / 4
			d(DsRicon .. GREENcolor .. GetString(DsRGuildPvP_ap_questtxt) .. APicon .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( difference ):gsub("%,","%.") .. GREENcolor .. " AP " .. lgIconText .. WHITEcolor .. currentAvARank .. GREYcolor .. " -> " .. ZO_CommaDelimitNumber( rankProgAvA ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( rankMaxAvA ):gsub("%,","%.") .. " ( " .. levelProgress .. " ) ")
			return
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- TelVar update & saver
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildPvP.TelVarPortToCyro()
	
	if not IsInImperialCity() then
		d(string.format(GetString(DsRGuildPvP_ap_telvarSaverPortBreak)))
		return
	end

	local PvPCampaignIDT = {
		CP_ImperialCity   = 95,
		NoCP_ImperialCity = 96,
		Blackreach        = 101,
		GrayHost          = 102,
		RavenWatch        = 103,
	}

	LocationsIC = LocationsIC or false
	inWaitInQueue = inWaitInQueue or false

	local function GetCampQWaitTime(inCampaignID)
		if not inCampaignID then inCampaignID = GetAssignedCampaignId() or 0 end
		for campaignIndex = 1, GetNumSelectionCampaigns() do 
			if inCampaignID == GetSelectionCampaignId(campaignIndex) then 
				local waitTime = GetSelectionCampaignQueueWaitTime(campaignIndex)
				return waitTime
			end
		end
		return 9999
	end

	local function GetLowestQueueWaitTimeCampID(LocationsIC)
		local lowCampID = 0
		local lowCampQTime = 999999
		LocationsIC = LocationsIC or false
		for campaignIndex = 1, GetNumSelectionCampaigns() do 
			local campID = GetSelectionCampaignId(campaignIndex)
			local qTime = GetSelectionCampaignQueueWaitTime(campaignIndex)
			if IsImperialCityCampaign(campID) == LocationsIC and DoesPlayerMeetCampaignRequirements(campID) == true then
				if qTime <= 5 then return campID end
				if qTime < lowCampQTime then
					lowCampID = campID
					lowCampQTime = qTime
				end
			end
		end
		return lowCampID
	end

	local campaignID = GetAssignedCampaignId() or PvPCampaignIDT.RavenWatch

	if LocationsIC == false then
		if inWaitInQueue == false then
			local waitTimeSecs = GetCampQWaitTime(campaignID)
			if waitTimeSecs > 3 then campaignID = GetLowestQueueWaitTimeCampID(LocationsIC) end
		end
	else campaignID = PvPCampaignIDT.CP_ImperialCity end

	local queueAsGroup = false
	if GetExpectedGroupQueueResult() == QUEUE_FOR_CAMPAIGN_RESULT_SUCCESS then
		DsRGuildPvP.pvp.PvPTelVarSaverQAsGroup = DsRGuildPvP.pvp.PvPTelVarSaverQAsGroup or false
		queueAsGroup = DsRGuildPvP.pvp.PvPTelVarSaverQAsGroup
	end
	
	if IsQueuedForCampaign(campaignID, queueAsGroup) then return end

	local Campaign = GetCampaignName(campaignID)

	d(string.format(GetString(DsRGuildPvP_ap_telvarSaverPort), Campaign))

	local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_SMALL_TEXT)
	params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_BATTLEGROUND_OBJECTIVE)
	params:SetText(zo_strformat(GetString(DsRGuildPvP_ap_telvarSaverPort), Campaign))
	CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)

	QueueForCampaign(campaignID, queueAsGroup) 
end

function DsRGuildPvP.OnTVUpdate(eventId, newTelvarStones, oldTelvarStones, reason, reasonSupplementaryInfo )
	if reason == CURRENCY_CHANGE_REASON_PLAYER_INIT then return end
	if not DsRGuildPvP.pvp.PvPTelVar then return end

	local bankedTelVarStones = GetBankedCurrencyAmount(CURT_TELVAR_STONES)
	local BagPackIcon        = [[esoui/art/inventory/inventory_tabicon_craftbag_up.dds]]

	local gain  = newTelvarStones - oldTelvarStones
	
	local maxTV = newTelvarStones + bankedTelVarStones

	if (gain == 0) then return end

	local TVicon = zo_iconTextFormat("esoui/art/icons/icon_telvarstone.dds", 20, 20, "")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local GREENcolor	  = "|c35fc38"
	local REDcolor	      = "|cFF0000"
	local BLUEcolor	      = "|c5C6BFF"

	if gain < 0 then
		d(TVicon .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. BLUEcolor .. " " .. GetString(DsRGuildPvP_ap_telvarmsg) .. WHITEcolor .. " -> " .. ZO_CommaDelimitNumber( newTelvarStones ):gsub("%,","%.") .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( maxTV ):gsub("%,","%.") .. " )")
	else
		d(TVicon .. GREENcolor .. " +" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. BLUEcolor .. " " .. GetString(DsRGuildPvP_ap_telvarmsg) .. WHITEcolor .. " -> " .. ZO_CommaDelimitNumber( newTelvarStones ):gsub("%,","%.") .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( maxTV ):gsub("%,","%.") .. " )")
	end
	
	if DsRGuildPvP.pvp.PvPTelVarSaver == 0 then return end

	if DsRGuildPvP.pvp.PvPTelVarSaver and newTelvarStones >= DsRGuildPvP.pvp.PvPTelVarSaver then
		DsRGuildPvP.TelVarPortToCyro()
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Kill Animation / notification / Counter
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildPvP.OnCombatKill(eventCode, result, isError, abilityName, abilityGraphic, abilityActionSlotType, sourceName, sourceType, targetName)
    if (IsInCampaign() or IsActiveWorldBattleground()) then
        if (isError) then return end
        if result == ACTION_RESULT_KILLING_BLOW and sourceType == COMBAT_UNIT_TYPE_PLAYER and GetUnitName("player") == zo_strformat("<<1>>", sourceName) then
            if (sourceName == targetName) then return end
			
			local Greencolor  = "|c35fc38"
			local REDcolor	  = "|cFF0000"
			local YELLOWcolor = "|cFFFF00"
	
			if abilityName ~= "" then  -- Tatsächlicher Todesstoß auf einem Spieler
            	if DsRGuildPvP.pvp.PvPKillenableFrame then 
					DSR_KillingBlowScreenFrame.animation:PlayFromStart()
					PlaySound(SOUNDS.SKILL_XP_DARK_ANCHOR_CLOSED)
				end
				if DsRGuildPvP.pvp.PvPKillBlowChat then
					d("|cC0FF3E" .. GetString(DsRGuildPvP_KillingBlowmsgA) .. YELLOWcolor .. zo_strformat("<<1>>", targetName) .. Greencolor .. GetString(DsRGuildPvP_KillingBlowmsgB) .. REDcolor .. zo_strformat("<<1>>", abilityName))
				end
				if DsRGuildPvP.pvp.PvPKillBlowScreen then
					local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_SMALL_TEXT)
					params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_BATTLEGROUND_OBJECTIVE)
					params:SetText("|cC0FF3E" .. GetString(DsRGuildPvP_KillingBlowmsgA) .. YELLOWcolor .. zo_strformat("<<1>>", targetName) .. Greencolor .. GetString(DsRGuildPvP_KillingBlowmsgB) .. REDcolor .. zo_strformat("<<1>>", abilityName))
					CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
				end
				DsRGuildPvP.pvp.sessionStats.killingBlows = DsRGuildPvP.pvp.sessionStats.killingBlows + 1
				DsRGuildPvPscore.ScoreWindow_Update()
			else -- Tötung eines Spielers ohne Todesstoß
				if DsRGuildPvP.pvp.PvPKillChat then
					PlaySound(SOUNDS.BATTLEGROUND_CAPTURE_AREA_CAPTURED_OWN_TEAM)
					d("|c97FFFF" .. GetString(DsRGuildPvP_KillingChat) .. YELLOWcolor .. zo_strformat("<<1>>", targetName))
				end
				DsRGuildPvP.pvp.sessionStats.kills = DsRGuildPvP.pvp.sessionStats.kills + 1
				DsRGuildPvPscore.ScoreWindow_Update()
			end
        end
    end
end

function  DsRGuildPvP.EventPlayerDead(eventCode)
	if (IsInCampaign() or IsActiveWorldBattleground()) then
		DsRGuildPvP.pvp.sessionStats.deaths = DsRGuildPvP.pvp.sessionStats.deaths + 1
		DsRGuildPvPscore.ScoreWindow_Update()
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Warteschlange
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildPvP_Periodic:New(inPeriodicFunc, inPeriodSecs)
    	
    local dsrPeriodicObj = ZO_Object.New(self)
    dsrPeriodicObj.periodicFunc = inPeriodicFunc
    dsrPeriodicObj.periodInSecs = inPeriodSecs or 60
    dsrPeriodicObj.isRegistered = false

    local bigRandom 		  = math.random(11111111, 99999999)
    local bigRandomStr 		  = string.format("%d",bigRandom)
    dsrPeriodicObj.identifier = "TBOP"..bigRandomStr
    return dsrPeriodicObj
end

function DsRGuildPvP_Periodic:Start(inPeriodicFunc, inPeriodSecs)

    if self.isRegistered == true then DsRGuildPvP_Periodic:Stop() end	

    self.periodicFunc = inPeriodicFunc or self.periodicFunc
    assert(self.periodicFunc ~= nil, "DsRGuildPvP_Periodic:New(): The 'periodicFunc' of the DsRGuildPvP_Periodic cannot be nil!")

    self.periodInSecs = inPeriodSecs or self.periodInSecs
    assert(self.periodInSecs > 0, "DsRGuildPvP_Periodic:Start(): The 'inPeriodSecs' parameter must be a positive integer!")

    self.periodicFunc()

    local updateMillisecs = self.periodInSecs * 1000
	EVENT_MANAGER:RegisterForUpdate(self.identifier, updateMillisecs, self.periodicFunc)
	self.isRegistered = true
end

function DsRGuildPvP_Periodic:Stop()
	if self.isRegistered == false then return end
	EVENT_MANAGER:UnregisterForUpdate(self.identifier)
	self.isRegistered = false
end

local function QueueTimeUpdate() 
	if DsRGuildPvP.queuedCampaignID == nil then return end
	local queueTime = GetSecondsInCampaignQueue(DsRGuildPvP.queuedCampaignID, DsRGuildPvP.queuedAsGroup or false)
	if not queueTime or queueTime == 0 then return end
	DsRGuildPvP.queueTimeInSecs = queueTime
	DsRGuildPvPscore.ScoreWindow_Update()
end


local function updateQueueInfo()
	local qSize 		= GetNumCampaignQueueEntries()
	local campID 		= nil
	local queuedAsGroup = nil

	if qSize > 0 then campID, queuedAsGroup = GetCampaignQueueEntry(qSize) end

	if campID then
		DsRGuildPvP.queuedCampaignID = campID
		DsRGuildPvP.queuedAsGroup 	 = queuedAsGroup
		DsRGuildPvP.queueState 		 = GetCampaignQueueState(campID, queuedAsGroup)
		DsRGuildPvP.queuePosition 	 = GetCampaignQueuePosition(campID, queuedAsGroup)
		DsRGuildPvP.queueTimeInSecs  = nil
		if DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_WAITING then 
			DsRGuildPvP.queueTimeInSecs = GetSecondsInCampaignQueue(campID, queuedAsGroup)
			DsRGuildPvP.queuePeriodic:Start(QueueTimeUpdate, 1)
		end
	end
end

function DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_JOINED(eventCode, campaignId, isGroupMember, willLockToAlliance)
	DsRGuildPvP.queuedCampaignID = campaignId 
	DsRGuildPvP.queuedAsGroup    = isGroupMember
	DsRGuildPvP.queueState       = GetCampaignQueueState(campaignId, isGroupMember)
	DsRGuildPvP.queuePosition    = GetCampaignQueuePosition(campaignId, isGroupMember)
	DsRGuildPvP.queueTimeInSecs  = GetSecondsInCampaignQueue(campaignId, isGroupMember)

	DsRGuildPvPscore.ScoreWindow_Update()
end

function DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_LEFT(eventCode, campaignId, isGroup)
	DsRGuildPvP.queuedCampaignID = nil
	DsRGuildPvP.queuePosition 	 = nil
	DsRGuildPvP.queueState 		 = nil

	DsRGuildPvP.queuePeriodic:Stop()
	DsRGuildPvP.queueTimeInSecs = nil

	updateQueueInfo()

	DsRGuildPvPscore.ScoreWindow_Update()
end

function DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_STATE_CHANGED(eventCode, campaignId, isGroup, state)
	DsRGuildPvP.queuedCampaignID = campaignId
	DsRGuildPvP.queueState 		 = state
	if DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_WAITING then 
		DsRGuildPvP.queuePeriodic:Start(QueueTimeUpdate, 1)
	else 
		DsRGuildPvP.queuePeriodic:Stop() 
		DsRGuildPvP.queueTimeInSecs = nil
	end

	DsRGuildPvPscore.ScoreWindow_Update()

	if state == CAMPAIGN_QUEUE_REQUEST_STATE_CONFIRMING then
        ConfirmCampaignEntry(campaignId, isGroup, true)
	end
end

function DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_POSITION_CHANGED(eventCode, campaignId, isGroup, position)
	DsRGuildPvP.queuedCampaignID = campaignId
	DsRGuildPvP.queuePosition 	 = position
	DsRGuildPvPscore.ScoreWindow_Update()
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- On addon loaded
-------------------------------------------------------------------------------------------------------------------------------------------------
local function LogoutOrQuit()
	DsRGuildPvP.pvp.sessionStats.kills 			= 0
	DsRGuildPvP.pvp.sessionStats.killStreak 	= 0
	DsRGuildPvP.pvp.sessionStats.killingBlows 	= 0
	DsRGuildPvP.pvp.sessionStats.kbStreak 		= 0
	DsRGuildPvP.pvp.sessionStats.deaths 		= 0
	DsRGuildPvP.pvp.sessionStats.alliancePoints = 0
end

function DsRGuildPvP.OnAddonLoaded(event, name)
	if DsRGuildPvP.pvp.PvPAP then
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_ALLIANCE_POINT_UPDATE, DsRGuildPvP.OnAPUpdated )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildPvP.name, EVENT_ALLIANCE_POINT_UPDATE )
	end
	if DsRGuildPvP.pvp.PvPTelVar then
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_TELVAR_STONE_UPDATE, DsRGuildPvP.OnTVUpdate )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildPvP.name, EVENT_TELVAR_STONE_UPDATE )
	end
	DSR_KillingBlowScreenFrameOverlay:SetEdgeColor(ZO_ColorDef:New(unpack(DsRGuildPvP.pvp.PvPKillframeColor)):UnpackRGBA())
	DSR_KillingBlowScreenFrame.animation = ANIMATION_MANAGER:CreateTimelineFromVirtual('DSR_KillingBlowScreenFrameAnimation', DSR_KillingBlowScreenFrame)
	
	EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_COMBAT_EVENT, DsRGuildPvP.OnCombatKill)
	EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_PLAYER_DEAD, DsRGuildPvP.EventPlayerDead)
	
	if DsRGuildPvP.pvp.enableQueueBar then
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_CAMPAIGN_QUEUE_JOINED, DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_JOINED)
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_CAMPAIGN_QUEUE_LEFT, DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_LEFT)
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_CAMPAIGN_QUEUE_STATE_CHANGED, DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_STATE_CHANGED)
		EVENT_MANAGER:RegisterForEvent(DsRGuildPvP.name, EVENT_CAMPAIGN_QUEUE_POSITION_CHANGED, DsRGuildPvP.EVENT_CAMPAIGN_QUEUE_POSITION_CHANGED)
	end

	ZO_PreHook("Logout", function() LogoutOrQuit() end)
	ZO_PreHook("Quit", function() LogoutOrQuit() end)
end
