-- Create namespace
DsRGuildPvPscore = {}
local DsRGuildPvPscore = DsRGuildPvPscore  or {}

local initTries = 0
function DsRGuildPvPscore.ScoreWindow_OnInitialized()
    -- Warteschlange muss sein, da ich die SavedVariable brauche

	if not DsRGuildPvP.pvp then 
        initTries = initTries + 1
        if initTries <= 10 then zo_callLater(function() DsRGuildPvPscore.ScoreWindow_OnInitialized() end, 1000) end
    else
	    DsRGuildPvPscore.ScoreWindow_RestorePosition()
	    DsRScoreWindow:SetMovable(not( DsRGuildPvP.pvp.statsBarLocked))
		local DsRGuildHall_hud_scene = ZO_SimpleSceneFragment:New(DsRScoreWindow)
		HUD_SCENE:AddFragment(DsRGuildHall_hud_scene)
		HUD_UI_SCENE:AddFragment(DsRGuildHall_hud_scene)

		if DsRGuildPvP.pvp.hideInPvE == false then
			DsRGuildPvPscore.ScoreWindow_Update()
		end
		DsRGuildPvPscore.ScoreWindow_Scale()
		DsRScoreWindowBG:SetHidden(true)
	end
end

function DsRGuildPvPscore.ScoreWindow_Update()
	local statsStr = nil

	if ( IsPlayerInAvAWorld() or IsActiveWorldBattleground() ) or ( DsRGuildPvP.pvp.hideInPvE == false) and DsRGuildPvP.pvp.enableQueueBar == true  then 

		local kills 		=  DsRGuildPvP.pvp.sessionStats.kills or 0
		local killStreak 	=  DsRGuildPvP.pvp.sessionStats.killStreak or 0
		local killingBlows 	=  DsRGuildPvP.pvp.sessionStats.killingBlows or 0
		local kbStreak 		=  DsRGuildPvP.pvp.sessionStats.kbStreak or 0
		local deaths 		=  DsRGuildPvP.pvp.sessionStats.deaths or 0
		local ap 			=  DsRGuildPvP.pvp.sessionStats.alliancePoints or 0
		local killsPerDeath = kills or 0

		if deaths > 0 then killsPerDeath = kills/deaths end

		local abbrevStr = string.format("|c97FFFF%s|r", GetString(DsRGuildPvP_KillingChat))
		local valStr 	= tostring(kills)
		if killStreak > 0 then valStr = valStr..string.format(" [%d]", killStreak) end
		valStr 			= string.format("|cFFFFFF%s|r", valStr)
		local killsStr 	= abbrevStr
		local killsCou 	= valStr
		
		abbrevStr 		= string.format("|cFF0000%s|r", GetString(DsRGuildPvP_KillingDeath))
		valStr 			= tostring(deaths)
		if kills > 0 and deaths > 0 then valStr = valStr .. string.format(" (%.1f)", killsPerDeath) end
		valStr 			= string.format("|cFFFFFF%s|r", valStr)
		local deathsStr = abbrevStr
		local deathsCou = valStr
		
		abbrevStr 			  = string.format("|cC0FF3E%s|r", GetString(DsRGuildPvP_KillingBlow))
		valStr 				  = tostring(killingBlows)
		if kbStreak > 0 then valStr = valStr..string.format(" [%d]", kbStreak) end
		valStr 				  = string.format("|cFFFFFF%s|r", valStr)
		local killingBlowsStr = abbrevStr
		local killingBlowsCou = valStr
		
		abbrevStr 	= string.format("|c2ADC22%s|r", GetString(DsRGuildPvP_KillingAP))
		valStr 		= string.format("|cFFFFFF%s|r", tostring(ap))
		local apStr = abbrevStr
		local apCou = valStr
	
		statsStr = string.format("%s\n%s\n%s\n%s", killingBlowsStr, killsStr, deathsStr, apStr)
		countStr = string.format("%s\n%s\n%s\n%s", killingBlowsCou, killsCou, deathsCou, apCou)
	end

	local qStr 	  = nil
	local timeStr = nil

	if DsRGuildPvP.queuedCampaignID then
		if DsRGuildPvP.queueState 	  == CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_JOIN 	 then qStr = GetString(DsRGuildPvP_qstate_QUEUEING)
		elseif DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_ACCEPT then qStr = GetString(DsRGuildPvP_qstate_ENTERING)
		elseif DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_PENDING_LEAVE  then qStr = GetString(DsRGuildPvP_qstate_LEAVING)
		elseif DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_CONFIRMING 	 then qStr = GetString(DsRGuildPvP_qstate_CONFIRMING)
		elseif DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_WAITING 		 then qStr = GetString(DsRGuildPvP_qstate_WAITING)
		elseif DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_FINISHED 	 	 then qStr = GetString(DsRGuildPvP_qstate_FINISHED)
		else qStr = GetString(DsRGuildPvP_qstate_UNKNOWN) end

		qStr = string.format(qStr, GetCampaignName(DsRGuildPvP.queuedCampaignID) or GetString(DsRGuildPvP_qstate_UNKNOWN_Q))

		if DsRGuildPvP.queueState == CAMPAIGN_QUEUE_REQUEST_STATE_WAITING and DsRGuildPvP.queuePosition ~= nil then
			qStr = string.format(GetString(DsRGuildPvP_qstate_Q_NUMBER) .. qStr, DsRGuildPvP.queuePosition)

			if DsRGuildPvP.queueTimeInSecs and DsRGuildPvP.queueTimeInSecs > 0 then
				timeStr = FormatTimeSeconds(DsRGuildPvP.queueTimeInSecs, 
											TIME_FORMAT_STYLE_DESCRIPTIVE_MINIMAL, 
											TIME_FORMAT_PRECISION_SECONDS, 
											TIME_FORMAT_DIRECTION_DESCENDING)
				timeStr = string.format(GetString(DsRGuildPvP_qstate_Q_TIME), timeStr)
			end 
		end
	end

	local topLine    = statsStr
	local CountLine  = countStr
	local bottomLine = qStr

	if not topLine and bottomLine then 
		topLine = bottomLine
		topLine = string.format("|cFFFFFF%s:|r", topLine)
		if not timeStr and DsRGuildPvP.campTimerStr then timeStr = DsRGuildPvP.campTimerStr end
		bottomLine = timeStr
	elseif bottomLine and timeStr then
		bottomLine = bottomLine .. "\n" .. timeStr
	elseif DsRGuildPvP.campTimerStr ~= nil then
		bottomLine = DsRGuildPvP.campTimerStr
	end

	if bottomLine then bottomLine = string.format("|cFFFFFF%s:|r", bottomLine) end

	if topLine then
		DsRScoreWindowTopLabel:SetHidden(false)
		DsRScoreWindowCountLabel:SetHidden(false)
		DsRScoreWindowTopLabel:SetText(topLine)
		DsRScoreWindowCountLabel:SetText(CountLine)
	else 
		DsRScoreWindowTopLabel:SetHidden(true)
		DsRScoreWindowCountLabel:SetHidden(true)
	end

	local topWidth  = DsRScoreWindowTopLabel:GetTextWidth() + 60
	local topHeight = DsRScoreWindowTopLabel:GetTextHeight() + 10

	if bottomLine then
		DsRScoreWindowBottomLabel:SetHidden(false)
		DsRScoreWindowBottomLabel:SetText(bottomLine)
	else 
		DsRScoreWindowBottomLabel:SetHidden(true) 
	end

	local shouldHideWindow = false

	if (topLine == nil and bottomLine == nil) then
	 	if  DsRGuildPvP.pvp.hideInPvE == true then
			topWidth = 40
	 	end
	end
	if DsRScoreWindow:GetWidth() ~= topWidth then DsRScoreWindow:SetWidth(topWidth) end
	if DsRScoreWindow:GetHeight() ~= topHeight then DsRScoreWindow:SetHeight(topHeight) end
	DsRScoreWindow:SetHidden(shouldHideWindow)
end

function DsRGuildPvPscore.ScoreWindow_Scale()
	DsRGuildPvP.pvp.scoreWindowScale =  DsRGuildPvP.pvp.scoreWindowScale or 0
	local scaleModifier = 1 + ( DsRGuildPvP.pvp.scoreWindowScale/100)
	if DsRScoreWindow:GetScale() ~= scaleModifier then DsRScoreWindow:SetScale(scaleModifier) end
end

function DsRGuildPvPscore.ScoreWindow_ToggleHidden()
	DsRScoreWindow:SetHidden(not DsRScoreWindow:IsHidden())
end

function DsRGuildPvPscore.ScoreWindow_Show()
	DsRGuildPvPscore.ScoreWindow_Update()	
	DsRScoreWindow:SetHidden(false)
end

function DsRGuildPvPscore.ScoreWindow_Hide()
	DsRScoreWindow:SetHidden(true)
end

function DsRGuildPvPscore.ScoreWindow_SaveAnchor()
	local isValidAnchor, currAnchorPoint, relativeTo, relativePoint, currXOff, currYOff, anchorConstrains = DsRScoreWindow:GetAnchor()

	DsRGuildPvP.pvp.scoreWindowanchorPoint = currAnchorPoint
	DsRGuildPvP.pvp.scoreWindowxOff        = currXOff
	DsRGuildPvP.pvp.scoreWindowyOff        = currYOff
end

function DsRGuildPvPscore.AdjustBtmLabel()
	local btmLineOffset = 27
	if  DsRGuildPvP.pvp.scoreWindowanchorPoint == 6 or  DsRGuildPvP.pvp.scoreWindowanchorPoint == 12 then btmLineOffset = -27 end

	local isValidAnchor, currAnchorPoint, relativeTo, relativePoint, currXOff, currYOff, anchorConstrains = DsRScoreWindowBottomLabel:GetAnchor()
	
	if currYOff ~= btmLineOffset then
		currYOff = btmLineOffset
		DsRScoreWindowBottomLabel:SetAnchor(currAnchorPoint, relativeTo, relativePoint, currXOff, currYOff, anchorConstrains)
	end
end

function DsRGuildPvPscore.ScoreWindow_OnMoveStop()
	DsRGuildPvPscore.ScoreWindow_SaveAnchor()
	DsRGuildPvPscore.AdjustBtmLabel()
end

function DsRGuildPvPscore.ScoreWindow_RestorePosition()
	
	if DsRGuildPvP.pvp.scoreWindowanchorPoint and ( not DsRGuildPvP.pvp.scoreWindowanchorPoint and not DsRGuildPvP.pvp.scoreWindowxOff and not DsRGuildPvP.pvp.scoreWindowyOff) then
		DsRGuildPvP.pvp.scoreWindowanchorPoint = DsRGuildPvP.pvp.scoreWindowanchorPoint
		DsRGuildPvP.pvp.scoreWindowxOff 	   = DsRGuildPvP.pvp.scoreWindowxOff
		DsRGuildPvP.pvp.scoreWindowyOff 	   = DsRGuildPvP.pvp.scoreWindowyOff
	end

	if ( not DsRGuildPvP.pvp.scoreWindowanchorPoint and not DsRGuildPvP.pvp.scoreWindowxOff and not DsRGuildPvP.pvp.scoreWindowyOff) then DsRGuildPvPscore.ScoreWindow_SaveAnchor() end

	DsRScoreWindow:ClearAnchors()
	DsRScoreWindow:SetAnchor( DsRGuildPvP.pvp.scoreWindowanchorPoint, GuiRoot, nil,  DsRGuildPvP.pvp.scoreWindowxOff,  DsRGuildPvP.pvp.scoreWindowyOff)
	DsRGuildPvPscore.AdjustBtmLabel()
end