-- Create namespace
DsRGuildReminder = {}
local DsRGuildReminder = DsRGuildReminder  or {}
local LFDB = LIB_FOOD_DRINK_BUFF

DsRGuildReminder.name = "DsRGuildReminder"

local update_timer_period = 30000 	-- milliseconds
local player_unit_tag     = "player"

-------------------------------------------------------------------------------------------------------------------------------------------------
-- ConsumeXP
-------------------------------------------------------------------------------------------------------------------------------------------------
local function DsRGuildReminder_ConsumeXP()
	local paramsXP = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_ANIMATED_CONTROL, SOUNDS.BOOK_ACQUIRED)
	paramsXP:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_SYSTEM_BROADCAST)
	paramsXP:SetLifespanMS(3500)

	local NoXPBuff = true

	local numBuffs         = GetNumBuffs(player_unit_tag)
	local hasActiveEffects = numBuffs > 0

	if hasActiveEffects then
		for i = 1, numBuffs do
			local buffName,_,timeEnding,_,_,iconFilename,_,_,_,_,abilityId,_,_ = GetUnitBuffInfo(player_unit_tag, i)
			if abilityId == 63570 or abilityId == 64210 or abilityId == 64537 or abilityId == 64630 
			or abilityId == 66776 or abilityId == 85501 or abilityId == 85502 or abilityId == 85503 or abilityId == 88445
			or abilityId == 89683 or abilityId == 99462 or abilityId == 99463 or abilityId == 135110 or abilityId == 138811
			then 
				local XPtimeLeftsec = math.floor(timeEnding - (GetFrameTimeMilliseconds()/1000))
				local XPtimeLeftmin = math.floor(XPtimeLeftsec / 60)

				local XPBuffer = math.floor(tonumber(DsRGuildLoot.sV.DsRReminderxpMinTime) * 60)

				if XPBuffer > 0 and XPtimeLeftsec <= XPBuffer then
					local XPAbIdName    = GetAbilityName(abilityId)
					local XPAdIdIcon    = GetAbilityIcon(abilityId)
					local XPAdIdColor   = "|cF7C42A"
					local XPmsg         = zo_iconTextFormat(XPAdIdIcon, 46, 46, "") .. XPAdIdColor .. XPAbIdName:gsub("%^.*", "")
					if XPtimeLeftsec < 119 then
						local XPmsgTime = zo_strformat(GetString(DsRGuildReminder_XPendSec), XPtimeLeftsec)
						paramsXP:SetText(XPmsg, XPmsgTime)
						CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsXP)
					else
						local XPmsgTime = zo_strformat(GetString(DsRGuildReminder_XPendMin), XPtimeLeftmin)
						paramsXP:SetText(XPmsg, XPmsgTime)
						CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsXP)
					end
				end
				NoXPBuff = false
			end
		end
		if NoXPBuff == true and DsRGuildLoot.sV.DsRReminderxpfalse == true then
			paramsXP:SetText(GetString(DsRGuildReminder_XPend))
			CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsXP)
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- ConsumeAP
-------------------------------------------------------------------------------------------------------------------------------------------------
local function DsRGuildReminder_ConsumeAP()
	local paramsAP = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_ANIMATED_CONTROL, SOUNDS.BOOK_ACQUIRED)
	paramsAP:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_SYSTEM_BROADCAST)
	paramsAP:SetLifespanMS(3500)
			
	local NoAPBuff = true

	local APnumBuffs         = GetNumBuffs(player_unit_tag)
	local APhasActiveEffects = APnumBuffs > 0

	if APhasActiveEffects then
		for i = 1, APnumBuffs do
			local buffName,_,timeEnding,_,_,iconFilename,_,_,_,_,abilityId,_,_ = GetUnitBuffInfo(player_unit_tag, i)
			if abilityId == 137733 or abilityId == 147466 or abilityId == 147467 or abilityId == 147687
			or abilityId == 147733 or abilityId == 147734 or abilityId == 147797
			then 
				local APtimeLeftsec = math.floor(timeEnding - (GetFrameTimeMilliseconds()/1000))
				local APtimeLeftmin = math.floor(APtimeLeftsec / 60)

				local APBuffer = math.floor(tonumber(DsRGuildLoot.sV.DsRReminderapMinTime) * 60)
				if APBuffer > 0 and APtimeLeftsec <= APBuffer then
					local APAbIdName    = GetAbilityName(abilityId)
					local APAdIdIcon    = GetAbilityIcon(abilityId)
					local APAdIdColor   = "|cF7C42A"
					local APmsg         = zo_iconTextFormat(APAdIdIcon, 46, 46, "") .. APAdIdColor .. APAbIdName:gsub("%^.*", "")
					if APtimeLeftsec < 119 then
						local APmsgTime = zo_strformat(GetString(DsRGuildReminder_APendSec), APtimeLeftsec)
						paramsAP:SetText(APmsg, APmsgTime)
						CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsAP)
					else
						local APmsgTime = zo_strformat(GetString(DsRGuildReminder_APendMin), APtimeLeftmin)
						paramsAP:SetText(APmsg, APmsgTime)
						CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsAP)
					end
				end
				NoAPBuff = false
			end
		end
		
		local inPvPZone      = IsPlayerInPvP()
		local inImperialZone = IsInImperialCity()

		if inPvPZone == true and inImperialZone == false then
			if NoAPBuff == true and DsRGuildLoot.sV.DsRReminderapfalse == true then
				paramsAP:SetText(GetString(DsRGuildReminder_APend))
				CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(paramsAP)
			end
		end
	end
end

function IsPlayerInPvP()
	-- IsPlayerInAvAWorld() will return 'true' if the player is in Cyrodiil, a Cyrodiil delve, Imperial City or the Imperial City sewers.
	-- IsActiveWorldBattleground() will return true if the player is in a Battleground.
	return IsPlayerInAvAWorld() or IsActiveWorldBattleground()
end


-------------------------------------------------------------------------------------------------------------------------------------------------
-- EatFood
-------------------------------------------------------------------------------------------------------------------------------------------------
local function DsRGuildReminder_EatFood(FOODabilityId)
	local isBuffActive, timeLeftInSeconds, abilityId = LFDB:IsFoodBuffActiveAndGetTimeLeft(player_unit_tag)
	local timeLeftInMinutes = math.floor(timeLeftInSeconds / 60)

	local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_ANIMATED_CONTROL, SOUNDS.BOOK_ACQUIRED)
	params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_SYSTEM_BROADCAST)
	params:SetLifespanMS(3500)

	if isBuffActive then
		local AbIdName  = GetAbilityName(FOODabilityId)
		local AdIdIcon  = GetAbilityIcon(FOODabilityId)
		local AdIdColor = "|c8525FA"
		local msgFood   = zo_iconTextFormat(AdIdIcon, 46, 46, "") .. AdIdColor .. AbIdName:gsub("%^.*", "")

		if timeLeftInSeconds < 119 then
			local msgTime = zo_strformat(GetString(DsRGuildReminder_FoodendSec), timeLeftInSeconds)
			params:SetText(msgFood, msgTime)

			CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
		else
			local msgTime = zo_strformat(GetString(DsRGuildReminder_FoodendMin), timeLeftInMinutes)
			params:SetText(msgFood, msgTime)

			CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- OnUpdateTimer
-------------------------------------------------------------------------------------------------------------------------------------------------
local function DsRGuildReminder_OnUpdateTimer() 
	
	if DsRGuildLoot.sV.DsRReminderfoodOnOff == true then
		local isFoodBuffActive, foodTimeLeftInSeconds, FOODabilityId = LFDB:IsFoodBuffActiveAndGetTimeLeft(player_unit_tag)
		
		if isFoodBuffActive then
			local foodBuffer = math.floor(tonumber(DsRGuildLoot.sV.DsRReminderBuffFoodMinTime) * 60)
			if foodBuffer > 0 and foodTimeLeftInSeconds <= foodBuffer then
				DsRGuildReminder_EatFood(FOODabilityId)
			end
		elseif DsRGuildLoot.sV.DsRReminderfoodfalse == true then
			local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_ANIMATED_CONTROL, SOUNDS.BOOK_ACQUIRED)
			params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_SYSTEM_BROADCAST)
			params:SetLifespanMS(3500)

			params:SetText(GetString(DsRGuildReminder_Foodend))
			CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
		end
	end
	
	if DsRGuildLoot.sV.DsRReminderxpOnOff == true then
		DsRGuildReminder_ConsumeXP()
	end
	
	if DsRGuildLoot.sV.DsRReminderapOnOff == true then
		DsRGuildReminder_ConsumeAP()
	end
end	

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Initialize
-------------------------------------------------------------------------------------------------------------------------------------------------
local function Initialize() 
	EVENT_MANAGER:RegisterForUpdate(DsRGuildReminder.name, update_timer_period, DsRGuildReminder_OnUpdateTimer)
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- OnAddOnLoaded
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildReminder.OnAddOnLoaded(event, name)
	EVENT_MANAGER:UnregisterForEvent(DsRGuildReminder.Name, eventCode)
	Initialize()
end