-- Create namespace
DsRGuildHoliday = {}

-- Footer
function DsRGuildHoliday.LoadIconHoliFooter()
    local IconFooter = DsRGuildHolidayIconFooter
    local ld = os.date("*t")
    local guildId   = GUILD_ROSTER_MANAGER:GetGuildId()
    local guildName = GetGuildName(guildId)
    
    if ld.month == 2 and ld.day == 14 then
-- Valentine's Day
        IconFooter:SetTexture("DsRGuildHall/misc/DsR/DsR_valentinheader.dds")
    elseif (ld.month == 3 and ld.day >= 20) and (ld.month == 4 and ld.day <= 1) then
-- Ester
        IconFooter:SetTexture("DsRGuildHall/misc/DsR/DsR_esterfooter.dds")
    elseif ld.month == 10 and ld.day >= 27 and ld.day <=31 then
-- Halloween
        IconFooter:SetTexture("DsRGuildHall/misc/DsR/DsR_halloweenfooter.dds")
    elseif ld.month == 12 and ld.day >= 0 and ld.day <= 26 then
-- Christmas
        IconFooter:SetTexture("DsRGuildHall/misc/DsR/DsR_xmasfooter.dds")
    elseif (ld.month == 12 and ld.day >= 29) and (ld.month == 1 and ld.day <= 3) then
-- New year
        IconFooter:SetTexture("DsRGuildHall/misc/DsR/DsR_newyearfooter.dds")
    else
        IconFooter:SetTexture("")
        IconFooter:SetHidden(true)
    end
    
    if not PerfectPixel and guildName == "Die sieben Raben" then
        IconFooter:SetAnchor(TOP, ZO_GuildHome, BOTTOM, 120 , 200)
    elseif not PerfectPixel and guildName ~= "Die sieben Raben" then
        IconFooter:SetAnchor(TOP, ZO_GuildHome, BOTTOM, 120 , -40)
    end
end

-- Header
function DsRGuildHoliday.LoadIconHoliHeader()
    local IconHeader = DsRGuildHolidayIconHeader
    local ld = os.date("*t")
    
    if ld.month == 2 and ld.day == 14 then
-- Valentine's Day
        IconHeader:SetTexture("DsRGuildHall/misc/DsR/DsR_valentinheader.dds")
    elseif (ld.month == 3 and ld.day >= 20) and (ld.month == 4 and ld.day <= 1) then
-- Ester
        IconHeader:SetTexture("DsRGuildHall/misc/DsR/DsR_esterheader.dds")
    elseif ld.month == 10 and ld.day >= 27 and ld.day <=31 then
-- Halloween
        IconHeader:SetTexture("DsRGuildHall/misc/DsR/DsR_halloweenheader.dds")
    elseif ld.month == 12 and ld.day >= 0 and ld.day <= 26 then
-- Christmas
        IconHeader:SetTexture("DsRGuildHall/misc/DsR/DsR_xmasheader.dds")
    elseif (ld.month == 1 and ld.day <= 3) then
-- New year
        IconHeader:SetTexture("DsRGuildHall/misc/DsR/DsR_newyearheader.dds")
    else
        IconHeader:SetTexture("")
        IconHeader:SetHidden(true)
    end
end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- change guild
function DsRGuildHoliday.OnGuildIdChanged(guild_roster_manager)
    local guildId   = GUILD_ROSTER_MANAGER:GetGuildId()
    local guildName = GetGuildName(guildId)
    local IconFooter = DsRGuildHolidayIconFooter

    if not PerfectPixel and guildName == "Die sieben Raben" then
        IconFooter:SetAnchor(TOP, ZO_GuildHome, BOTTOM, 120 , 200)
    elseif not PerfectPixel and guildName ~= "Die sieben Raben" then
        IconFooter:SetAnchor(TOP, ZO_GuildHome, BOTTOM, 120 , -40)
    end
end