-- Create namespace
DsRGuildLoot = {}
local DsRGuildLoot = DsRGuildLoot  or {}

DsRGuildLoot.name = "DsRGuildLoot"

DsRGuildLoot.MailStacks	= {}
DsRGuildLoot.recentLoot = {}

function DsRGuildLoot.OnGroupChanged()
	DsRGuildLoot.GroupNames = {}
	if IsUnitGrouped("player") then
		if DsRGuildLoot.sV.ChatGroupLoot then
			local groupSize = GetGroupSize()
			for s = 1, groupSize do
				local unitTag = GetGroupUnitTagByIndex(s)
				if (DoesUnitExist(unitTag)) then
					local displayName = zo_strformat(SI_UNIT_NAME, GetUnitDisplayName(unitTag))
					local unitName = zo_strformat(SI_UNIT_NAME, GetUnitName(unitTag))
					DsRGuildLoot.GroupNames[unitName] = displayName
				end
			end
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Output Centerscreen
-------------------------------------------------------------------------------------------------------------------------------------------------
local function announceSCREEN(quantity, itemName, colorItem, lgIconText, craftBagCount, TradingPrice)
	if DsRGuildLoot.sV.ScreenOnOff == true then return end

	local BagPackIcon     = [[esoui/art/inventory/inventory_tabicon_craftbag_up.dds]]
	local BagPackIconText = zo_iconTextFormat(BagPackIcon, 32, 32, "")
	local colorBagPack    = "|c808080"

	local params        = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_SMALL_TEXT)

	local tradeIcon     = [[/DsRGuildHall/misc/DsR/tradehammer.dds]]
	local tradeIconText = zo_iconTextFormat(tradeIcon, 20, 20, "")
	local colortrade    = "|cFFAE42"

	local quantityColor = "|cFFFF00"

	BagCount = ZO_CommaDelimitNumber( craftBagCount ):gsub("%,","%.")
	
	params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_BATTLEGROUND_OBJECTIVE)
	if DsRGuildLoot.sV.ScreenTradePrice == true then
		if quantity > 1 then
			params:SetText(lgIconText .. quantityColor .. quantity .. "x " .. colorItem .. itemName .. colorBagPack .. " ( " .. BagCount .. BagPackIconText .. ") " .. colortrade .. tradeIconText ..  TradingPrice .. "g")
		else
			params:SetText(lgIconText .. colorItem .. itemName .. colorBagPack .. " ( " .. BagCount .. BagPackIconText .. ") " .. colortrade .. tradeIconText ..  TradingPrice .. "g")
		end
	else
		if quantity > 1 then
			params:SetText(lgIconText .. quantityColor .. quantity .. "x " .. colorItem .. itemName .. colorBagPack .. " ( " .. BagCount .. BagPackIconText .. ")")
		else
			params:SetText(lgIconText .. colorItem .. itemName .. colorBagPack .. " ( " .. BagCount .. BagPackIconText .. ")")
		end
	end

	CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
end
-------------------------------------------------------------------------------------------------------------------------------------------------
-- Output Chat
-------------------------------------------------------------------------------------------------------------------------------------------------
local function announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
	if DsRGuildLoot.sV.ChatOnOff == true then return end

	local BagPackIcon     = [[esoui/art/inventory/inventory_tabicon_craftbag_up.dds]]
	local BagPackIconText = zo_iconTextFormat(BagPackIcon, 20, 20, "")
	local colorBagPack    = "|c808080"

	local tradeIcon     = [[/DsRGuildHall/misc/DsR/tradehammer.dds]]
	local tradeIconText = zo_iconTextFormat(tradeIcon, 20, 20, "")
	local colortrade    = "|cFFAE42"

	local receivedByColor = "|c7393B3"
	local WHITEcolor      = "|cFFFFFF"
	
	BagCount = ZO_CommaDelimitNumber( totalCount ):gsub("%,","%.")

	if itemId == 56863 or itemId == 56862 or itemId == 68342 or itemId == 204881 then
		itemLink = LocalizeString("<<1>>", GetItemLinkName(itemLink))
	end

	if self then
		if DsRGuildLoot.sV.ChatTradePrice == true then
			if tonumber(quantity) > 1 then
				d(lgIconText .. quantity .. "x " .. colorItem .. itemLink .. colorBagPack .. " ( " ..  BagCount .. BagPackIconText .. ") " .. colortrade .. tradeIconText ..  TradingPrice .. "g")
			else
				d(lgIconText ..  colorItem .. itemLink .. colorBagPack .. " ( " ..  BagCount .. BagPackIconText .. ") " .. colortrade .. tradeIconText ..  TradingPrice .. "g")
			end
		else
			if tonumber(quantity) > 1 then
				d(lgIconText .. quantity .. "x " .. colorItem .. itemLink .. colorBagPack .. " ( " ..  BagCount .. BagPackIconText .. ")")
			else
				d(lgIconText ..  colorItem .. itemLink .. colorBagPack .. " ( " ..  BagCount .. BagPackIconText .. ")")
			end
		end
	elseif not self and DsRGuildLoot.sV.ChatGroupLoot == true then
		ACCname  = ZO_LinkHandler_CreatePlayerLink(DsRGuildLoot.GroupNames[zo_strformat(SI_UNIT_NAME, receivedBy)])
		if DsRGuildLoot.sV.ChatTradePrice == true then
			if tonumber(quantity) > 1 then
				d(receivedByColor .. ACCname .. WHITEcolor .. " " .. lgIconText .. quantity .. "x " .. colorItem .. itemLink .. colortrade .. tradeIconText ..  TradingPrice .. "g")
			else
				d(receivedByColor .. ACCname .. WHITEcolor .. " " .. lgIconText .. colorItem .. itemLink .. colortrade .. tradeIconText ..  TradingPrice .. "g")
			end
		else
			if tonumber(quantity) > 1 then
				d(receivedByColor .. ACCname .. WHITEcolor .. " " .. lgIconText .. quantity .. "x " .. colorItem .. itemLink)
			else
				d(receivedByColor .. ACCname .. WHITEcolor .. " " .. lgIconText ..  colorItem .. itemLink)
			end
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Trading price
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.TradePrices(itemLink)
	local MM     = 0
	local TTC    = 0
	local ATT    = 0
	local Price  = 0
	local isLink = (string.find(itemLink, "|H(.-):item:(.-)|h(.-)|h") ~= nil) and true or false

	if MasterMerchant ~= nil then
		local mmPrice = (isLink) and MasterMerchant:itemStats(itemLink, false) or nil
		if not mmPrice or mmPrice.avgPrice == nil or mmPrice.avgPrice == 0 then
			MM = 0
		else
			MM = mmPrice.avgPrice
		end
	end
	if TamrielTradeCentre ~= nil then
		local ttcPrice = (isLink) and TamrielTradeCentrePrice:GetPriceInfo(itemLink) or nil
		if not ttcPrice or ttcPrice == 0 or ttcPrice == nil then
			TTC = 0
		else			
			TTC = ttcPrice.SuggestedPrice
		end
	end
	if ArkadiusTradeTools ~= nil then
		local avgPrice = (isLink) and ArkadiusTradeTools.Modules.Sales:GetAveragePricePerItem(itemLink, nil, nil) or nil
		if not avgPrice or avgPrice == 0 or avgPrice == nil then
			ATT = 0
		else
			ATT = avgPrice
		end
	end

	local tVals = {[1] = MM, [2] = TTC, [3] = ATT}
	for k, v in pairs(tVals) do
		if v > 0 then
			if v > Price then
				Price = v
			else
				Price = Price
			end
		end
	end
	PriceRound = zo_roundToNearest( Price , 0.1 )
	if Price ~= 0 then Price = ZO_CommaDelimitNumber( PriceRound ):gsub("%,","%.") end
	return Price
end
-------------------------------------------------------------------------------------------------------------------------------------------------
-- On loot
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnLootReceived(_, receivedBy, itemLink, quantity, _, lootType, self, _, questIcon, itemId) 
	local pName = zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemLinkName(itemLink))
	if (pName == LootDrop_SoulGem or pName == LootDrop_EmptyGem) then return end

	TradingPrice = DsRGuildLoot.TradePrices(itemLink,quantity)

	local itemName 	       = GetItemLinkName(itemLink)
	local itemIcon 	       = GetItemLinkIcon(itemLink)
	local itemquality      = GetItemLinkQuality(itemLink)
	local itemqualityColor = GetItemQualityColor(itemquality)
	local _, sellPrice     = GetItemLinkInfo(itemLink)

	if tonumber(TradingPrice) == 0 then
		TradingPrice = ZO_CommaDelimitNumber( zo_roundToNearest( sellPrice , 0.1 ) ):gsub("%,","%.")
	end
	
	local bagCount, bankCount, craftBagCount = GetItemLinkStacks(itemLink)
	local totalCount 						 = bagCount + bankCount + craftBagCount
	
	local fN    = LocalizeString("<<1>>", itemName)
	local quali = LocalizeString("<<1>>", itemquality)
	
	local colorItem = zo_strformat("|c<<1>>", itemqualityColor:ToHex())

-- Centerscreen
	if self then
		if DsRGuildLoot.sV.ScreensNirn == true and itemId == 56863 then -- Potent Nirncrux ID: 56863
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFF0000"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenfNirn == true and itemId == 56862 then -- Stable Nirncrux ID: 56862
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFF0000"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenKuta == true and itemId == 45854 then  --  Kuta ID: 45854
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenHakeijo == true and itemId == 68342 then  --  Hakeijo ID: 68342
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFFD700"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenLuminousInk == true and itemId == 204881 then  --  LuminousInk ID: 204881
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|c33ABF5"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif quali >= zo_strsub(DsRGuildLoot.sV.ScreenQualiloot , 1 , 1) then  -- Auswahlliste ab welcher QUALI
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		end
	end
-- CHAT
	if self then
		if DsRGuildLoot.sV.ChatsNirn == true and itemId == 56863 then -- Potent Nirncrux ID: 56863
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatfNirn == true and itemId == 56862 then -- Stable Nirncrux ID: 56862
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatKuta == true and itemId == 45854 then  --  Kuta ID: 45854
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatHakeijo == true and itemId == 68342 then  --  Hakeijov ID: 68342
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFFD700"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatLuminousInk == true and itemId == 204881 then  --  LuminousInk ID: 204881
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|c33ABF5"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif quali >= zo_strsub(DsRGuildLoot.sV.ChatQualiloot , 1 , 1) then  -- Auswahlliste ab welcher QUALI
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")  
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		end
	elseif not self and DsRGuildLoot.sV.ChatGroupLoot == true then
		if DsRGuildLoot.sV.ChatsNirn == true and itemId == 56863 then -- Potent Nirncrux ID: 56863
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatfNirn == true and itemId == 56862 then -- Stable Nirncrux ID: 56862
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatKuta == true and itemId == 45854 then  --  Kuta ID: 45854
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatHakeijo == true and itemId == 68342 then  --  Hakeijo ID: 68342
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFFD700"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif DsRGuildLoot.sV.ChatLuminousInk == true and itemId == 204881 then  --  LuminousInk ID: 204881
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|c33ABF5"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		elseif quali >= zo_strsub(DsRGuildLoot.sV.ChatQualiGroupLoot , 1 , 1) then  -- Auswahlliste ab welcher QUALI
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")  
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self, itemId)
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- MAIL loot
-------------------------------------------------------------------------------------------------------------------------------------------------
-- Wird aufgerufen wenn der Anhang entnommen wird
function DsRGuildLoot.OnMailItemLooted(mailId)
	for mailitemindex, item in pairs(DsRGuildLoot.MailStacks) do
		local itemLink = item.itemLink

		TradingPrice = DsRGuildLoot.TradePrices(itemLink,item.stack)
	
		local quantity		   = tonumber(item.stack)
		local itemName 	       = GetItemLinkName(itemLink)
		local itemIcon 	       = GetItemLinkIcon(itemLink)
		local itemquality      = GetItemLinkQuality(itemLink)
		local itemqualityColor = GetItemQualityColor(itemquality)
		local itemId		   = GetItemLinkItemId(itemLink)
	
		local bagCount, bankCount, craftBagCount = GetItemLinkStacks(itemLink)
		local totalCount 						 = bagCount + bankCount + craftBagCount
		
		local fN    = LocalizeString("<<1>>", itemName)
		local quali = LocalizeString("<<1>>", itemquality)
		
		local colorItem  = zo_strformat("|c<<1>>", itemqualityColor:ToHex())
		local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
		local receivedBy = ""
		local self 		 = true
	
	-- CENTERSCREEN
		if DsRGuildLoot.sV.ScreensNirn == true and itemId == 56863 then -- Potent Nirncrux ID: 56863
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFF0000"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenfNirn == true and itemId == 56862 then -- Stable Nirncrux ID: 56862
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFF0000"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenKuta == true and itemId == 45854 then  --  Kuta ID: 45854
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenHakeijo == true and itemId == 68342 then  --  Hakeijo ID: 68342
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			local colorItem  = "|cFFD700"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif DsRGuildLoot.sV.ScreenLuminousInk == true and itemId == 204881 then  --  LuminousInk ID: 204881
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|c33ABF5"
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		elseif quali >= zo_strsub(DsRGuildLoot.sV.ScreenQualiloot , 1 , 1) then  -- Auswahlliste ab welcher QUALI
			local lgIconText = zo_iconTextFormat(itemIcon, 32, 32, " ")
			announceSCREEN(quantity, fN, colorItem, lgIconText, totalCount, TradingPrice)
		end
	-- CHAT
		if DsRGuildLoot.sV.ChatsNirn == true and itemId == 56863 then -- Potent Nirncrux ID: 56863
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		elseif DsRGuildLoot.sV.ChatfNirn == true and itemId == 56862 then -- Stable Nirncrux ID: 56862
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFF0000"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		elseif DsRGuildLoot.sV.ChatKuta == true and itemId == 45854 then  --  Kuta ID: 45854
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		elseif DsRGuildLoot.sV.ChatHakeijo == true and itemId == 68342 then  --  Hakeijo ID: 68342
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|cFFD700"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		elseif DsRGuildLoot.sV.ChatLuminousInk == true and itemId == 204881 then  --  LuminousInk ID: 204881
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")
			local colorItem  = "|c33ABF5"
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		elseif quali >= zo_strsub(DsRGuildLoot.sV.ChatQualiloot , 1 , 1) then  -- Auswahlliste ab welcher QUALI
			local lgIconText = zo_iconTextFormat(itemIcon, 20, 20, " ")  
			announceCHAT(_, receivedBy, itemLink, quantity, colorItem, lgIconText, totalCount, TradingPrice, self)
		end
	end

	DsRGuildLoot.MailStacks = {}
	DsRGuildLoot.recentLoot = {}
end
-------------------------------------------------------------------------------
-- Wenn eine Nachricht gelesen wird
function DsRGuildLoot.OnMailReadable(mailId)
	local numAttachments = GetMailAttachmentInfo(mailId)

	DsRGuildLoot.MailStacks = {}

	for attachIndex = 1, numAttachments do
		DsRGuildLoot.MailStacks[attachIndex] = {}
		local icon, stack, _, _, _, _, itemStyle, quality = GetAttachedItemInfo( mailId, attachIndex)
		local mailitemlink                                = GetAttachedItemLink( mailId, attachIndex, LINK_STYLE_DEFAULT)
		local mailitemName                                = GetItemLinkName(mailitemlink)
		DsRGuildLoot.MailStacks[attachIndex].icon         = icon
		DsRGuildLoot.MailStacks[attachIndex].stack        = stack
		DsRGuildLoot.MailStacks[attachIndex].itemLink     = mailitemlink
		DsRGuildLoot.MailStacks[attachIndex].itemName     = zo_strformat(SI_TOOLTIP_ITEM_NAME, mailitemName)
		DsRGuildLoot.MailStacks[attachIndex].tType        = GetItemLinkItemType(mailitemlink)
		DsRGuildLoot.MailStacks[attachIndex].quality      = quality
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- XP update
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnXPUpdated( _, level, previousExperience, currentExperience, championPoints )
	if not DsRGuildLoot.sV.ChatXP then return end
	
	local gain = currentExperience - previousExperience
	if (gain <= 0) then return end
	if tonumber(gain) < tonumber(DsRGuildLoot.sV.ChatXPtxt) then return end

	local maxLevel = GetMaxLevel()
	local realLevel = "Rang "..tostring(level)

	if level == 50 then realLevel = zo_iconTextFormatNoSpace("esoui/art/champion/champion_icon_32.dds",18,18,"")..championPoints end	
	
	local xpForLevelUp
	
	if level < maxLevel then
		xpForLevelUp  = GetNumExperiencePointsInLevel(level)
	else
		local cPoints = GetNumChampionXPInChampionPoint(championPoints)
		xpForLevelUp  = (cPoints ~= nil) and cPoints or 0
	end
	
	local levelProgress   = tostring(math.floor(100*(currentExperience/xpForLevelUp))).."%"
	local lgIconText      = zo_iconTextFormat("/DsRGuildHall/misc/DsR/DsR_XP.dds", 20, 20, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local YELLOWcolor	  = "|cFFFF00"

	d(lgIconText .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. YELLOWcolor .. GetString(DsRGuildLoot_experience) .. WHITEcolor .. realLevel .. GREYcolor .. "  ->  " .. ZO_CommaDelimitNumber( currentExperience ):gsub("%,","%.") .. "/" .. ZO_CommaDelimitNumber( xpForLevelUp ):gsub("%,","%.") .. " ( " .. levelProgress .. " )")
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Money loot
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnMoneyUpdated( newMoney, oldMoney, reason )
	if reason == CURRENCY_CHANGE_REASON_PLAYER_INIT then return end
	if not DsRGuildLoot.sV.ChatGold then return end
	
	local gain = newMoney - oldMoney
	if (gain == 0) then return end
	if tonumber(gain) < tonumber(DsRGuildLoot.sV.ChatGoldtxt) then return end

	local lgIconText = zo_iconTextFormat("/esoui/art/currency/currency_gold.dds", 20, 20, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local REDcolor	      = "|cFF0000"
	local YELLOWcolor	  = "|cFFFF00"

	if gain < 0 then
		d(lgIconText .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. YELLOWcolor .. GetString(DsRGuildLoot_gold_gain) .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( newMoney ):gsub("%,","%.") .. " )")
	else
		d(lgIconText .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. YELLOWcolor .. GetString(DsRGuildLoot_gold_gain) .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( newMoney ):gsub("%,","%.") .. " )")
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Loot Undaunted, Transmute, etickets, endeavor, endless
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.AccountCurrencies()
	local undaunted = DsRGuildLoot.sV.ChatUnerschrocken
	local transmute = DsRGuildLoot.sV.ChatTransmut
	local eticket   = DsRGuildLoot.sV.Chatetickets
	local endeavor  = DsRGuildLoot.sV.ChatBestrebung
	local endless   = DsRGuildLoot.sV.ChatEndless

	if ( undaunted ) or ( transmute ) or ( eticket ) or ( endeavor ) or ( endless ) then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_CURRENCY_UPDATE, function( _, ... ) DsRGuildLoot.OnCurrencyUpdate( ... ) end )
	else
		EVENT_MANAGER:UnregisterForEvent( EVENT_CURRENCY_UPDATE )
	end
end

function DsRGuildLoot.OnCurrencyUpdate(currencyType, currencyLocation, newAmount, oldAmount, reason)
	if reason == CURRENCY_CHANGE_REASON_PLAYER_INIT then return end

	if currencyType == CURT_UNDAUNTED_KEYS and DsRGuildLoot.sV.ChatUnerschrocken == true then
		DsRGuildLoot.OnUndauntedUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_CHAOTIC_CREATIA and DsRGuildLoot.sV.ChatTransmut == true then
		DsRGuildLoot.OnTransmuteUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_EVENT_TICKETS and DsRGuildLoot.sV.Chatetickets == true then
		DsRGuildLoot.OnETicketUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_ENDEAVOR_SEALS and ( DsRGuildLoot.sV.ChatBestrebung == true or DsRGuildLoot.sV.ScreenBestrebung == true ) then
		DsRGuildLoot.OnEndeavorUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_ENDLESS_DUNGEON and DsRGuildLoot.sV.ChatEndless == true then
		DsRGuildLoot.OnEndlessUpdate( newAmount, oldAmount )
	end
end
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnUndauntedUpdate( newUndaunted, oldUndaunted )
	if not DsRGuildLoot.sV.ChatUnerschrocken then return end

	local gain = newUndaunted - oldUndaunted
	if (gain == 0) then return end

	local lgIconText = zo_iconTextFormat("/esoui/art/currency/undauntedkey.dds", 20, 20, " ")
	local ACCIconText = zo_iconTextFormat("/esoui/art/inventory/inventory_currencytab_accountwide_up.dds", 22, 22, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local YELLOWcolor	  = "|cFFFF00"

	d(lgIconText .. WHITEcolor .. " +" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. YELLOWcolor .. GetString(DsRGuildLoot_undauntedkeys) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newUndaunted ):gsub("%,","%.") .. " )")
end
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnTransmuteUpdate( newTransmute, oldTransmute )
	if not DsRGuildLoot.sV.ChatTransmut then return end

	local gain = newTransmute - oldTransmute
	if (gain == 0) then return end

	local max = GetMaxPossibleCurrency(CURT_CHAOTIC_CREATIA, CURRENCY_LOCATION_ACCOUNT)

	local lgIconText = zo_iconTextFormat("/esoui/art/currency/currency_seedcrystal_mipmap.dds", 20, 20, " ")
	local ACCIconText = zo_iconTextFormat("/esoui/art/inventory/inventory_currencytab_accountwide_up.dds", 22, 22, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local REDcolor	      = "|cFF0000"
	local YELLOWcolor	  = "|cFFFF00"
	local TRANScolor	  = "|c5C6BFF"

	if gain < 0 then
		d(lgIconText .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. TRANScolor .. GetString(DsRGuildLoot_transmute_crystals) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newTransmute ):gsub("%,","%.") .. " / " .. ZO_CommaDelimitNumber( max ):gsub("%,","%.") .. " )")
	else
		d(lgIconText .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. TRANScolor .. GetString(DsRGuildLoot_transmute_crystals) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newTransmute ):gsub("%,","%.") .. " / " .. ZO_CommaDelimitNumber( max ):gsub("%,","%.") .. " )")
	end
end
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnETicketUpdate( newETicket, oldETicket )
	if not DsRGuildLoot.sV.Chatetickets then return end

	local gain = newETicket - oldETicket
	if (gain == 0) then return end

	local max = GetMaxPossibleCurrency(CURT_EVENT_TICKETS, CURRENCY_LOCATION_ACCOUNT)

	local lgIconText = zo_iconTextFormat("/esoui/art/currency/icon_eventticket_loot.dds", 20, 20, " ")
	local ACCIconText = zo_iconTextFormat("/esoui/art/inventory/inventory_currencytab_accountwide_up.dds", 22, 22, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local REDcolor	      = "|cFF0000"
	local YELLOWcolor	  = "|cFFFF00"
	local Eventcolor	  = "|cFD80A6"

	if gain < 0 then
		d(lgIconText .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. Eventcolor .. GetString(DsRGuildLoot_event_Tickets) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newETicket ):gsub("%,","%.") .. " / " .. ZO_CommaDelimitNumber( max ):gsub("%,","%.") .. " )")
	else
		d(lgIconText .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. Eventcolor .. GetString(DsRGuildLoot_event_Tickets) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newETicket ):gsub("%,","%.") .. " / " .. ZO_CommaDelimitNumber( max ):gsub("%,","%.") .. " )")
	end
end
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnEndeavorUpdate( newEndeavor, oldEndeavor )
	local gain = newEndeavor - oldEndeavor
	if (gain == 0) then return end

	local lgIconTextChat    = zo_iconTextFormat("/esoui/art/currency/currency_seals_of_endeavor_32.dds", 20, 20, " ")
	local lgIconTextScreen  = zo_iconTextFormat("/esoui/art/currency/currency_seals_of_endeavor_32.dds", 32, 32, " ")
	local ACCIconText       = zo_iconTextFormat("/esoui/art/inventory/inventory_currencytab_accountwide_up.dds", 22, 22, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local REDcolor	      = "|cFF0000"
	local YELLOWcolor	  = "|cFFFF00"
	local ENDEAVORcolor	  = "|cA52A2A"

	if DsRGuildLoot.sV.ChatBestrebung then
		if gain < 0 then
			d(lgIconTextChat .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. ENDEAVORcolor .. GetString(DsRGuildLoot_endeavor) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newEndeavor ):gsub("%,","%.") .. " )")
		else
			d(lgIconTextChat .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. ENDEAVORcolor .. GetString(DsRGuildLoot_endeavor) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newEndeavor ):gsub("%,","%.") .. " )")
		end
	end

	if DsRGuildLoot.sV.ScreenBestrebung then
		local params = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_SMALL_TEXT)
		params:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_BATTLEGROUND_OBJECTIVE)
		if gain < 0 then
			params:SetText(lgIconTextScreen .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. ENDEAVORcolor .. GetString(DsRGuildLoot_endeavor) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newEndeavor ):gsub("%,","%.") .. " )" )
		else
			params:SetText(lgIconTextScreen .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. ENDEAVORcolor .. GetString(DsRGuildLoot_endeavor) .. GREYcolor .. " ( " .. ACCIconText .. ZO_CommaDelimitNumber( newEndeavor ):gsub("%,","%.") .. " )" )
		end
		CENTER_SCREEN_ANNOUNCE:AddMessageWithParams(params)
	end
end
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnEndlessUpdate( newEndless, oldEndless )
	if not DsRGuildLoot.sV.ChatEndless then return end

	local gain = newEndless - oldEndless
	if (gain == 0) then return end

	local lgIconText = zo_iconTextFormat("/esoui/art/currency/archivalfragments_mipmaps.dds", 20, 20, " ")

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"
	local REDcolor	      = "|cFF0000"
	local YELLOWcolor	  = "|cFFFF00"

	if gain < 0 then
		d(lgIconText .. REDcolor .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. YELLOWcolor .. GetString(DsRGuildLoot_archival_fortunes) .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( newEndless ):gsub("%,","%.") .. " )")
	else
		d(lgIconText .. WHITEcolor .. "+" .. ZO_CommaDelimitNumber( gain ):gsub("%,","%.") .. " " .. YELLOWcolor .. GetString(DsRGuildLoot_archival_fortunes) .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( newEndless ):gsub("%,","%.") .. " )")
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Achievement
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.AchievementComplete(name, points, id, link)
	if not DsRGuildLoot.sV.ChatArchivments then return end

	local _, _, _, icon = GetAchievementInfo(id)
	local aLink 		= GetAchievementLink(id)
	local GREENcolor	= "|c008000"
	local GREYcolor	    = "|c808080"

	local lgIconText    = zo_iconTextFormat(icon, 20, 20, " ")
	
	d(lgIconText .. " " .. aLink .. GREENcolor .. " " .. GetString(DsRGuildLoot_cAchievementsTxt) .. GREYcolor .. " ( " .. ZO_CommaDelimitNumber( points ):gsub("%,","%.") .. " )")
end

function DsRGuildLoot.AchievementUpdated(id, preview)
	if not DsRGuildLoot.sV.ChatArchivmentsStatus then return end

	local name, _, _, icon, completed = GetAchievementInfo(id)
	local nCrit = GetAchievementNumCriteria(id)
	local aLink = GetAchievementLink(id)
	local cText = ""

	if nCrit > 1 then
		local cTotal = 0
		for i = 1, nCrit do
			local cDesc, cCom, cReq = GetAchievementCriterion(id, i)
			if cCom >= cReq then cTotal = cTotal + 1 end
		end
		cText = ' (' .. tostring(cTotal) .. '/' .. tostring(nCrit) .. ')'
	else
		local cDesc, cCom, cReq = GetAchievementCriterion(id, 1)
		cText = ' (' .. tostring(cCom) .. '/' .. tostring(cReq) .. ')'
	end

	local WHITEcolor      = "|cFFFFFF"
	local GREYcolor	      = "|c808080"

	local lgIconText = zo_iconTextFormat(icon, 20, 20, " ")

	d("|cA52A2AUpdate: |r" .. lgIconText .. " " .. aLink .. WHITEcolor .. " " .. GetString(DsRGuildLoot_pAchievementsTxt) .. GREYcolor .. cText)
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Books
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnLoreBookLearned(categoryIndex, collectionIndex, bookIndex, guildIndex, isMaxRank)
	if not DsRGuildLoot.sV.ChatBookLoot then return end

	local collectionName, collectionDescription, numKnownBooks, totalBooks, hidden, gamepadIcon, collectionId = GetLoreCollectionInfo(categoryIndex, collectionIndex)
	local bookTitle, bookIcon, bookKnown, bookId = GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex)
	local quantitiesTxt = ""

	if totalBooks ~= nil and totalBooks > 0 then
		quantitiesTxt = zo_strformat(" |c808080(<<1>>/<<2>>)|r", numKnownBooks, totalBooks)
	end
	local collectionIcon = zo_iconTextFormat("esoui/art/journal/journal_tabicon_lorelibrary_down.dds", 20, 20, " ")

	local lgIconText = zo_iconTextFormat(bookIcon, 20, 20, " ")

	local WHITEcolor  = "|cFFFFFF"
	local GREYcolor	  = "|c808080"
	if numKnownBooks ~= totalBooks then
		d(lgIconText .. bookTitle .. " " .. collectionIcon .. " " .. WHITEcolor  .. collectionName .. GREYcolor .. quantitiesTxt)
	end
end
-------------------------------------------------------------------------------------------------------------------------------------------------
-- XP Skills
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot:OnSkillXPUpdated( eventId,  skillType,  skillIndex,  reason,  rank,  previousXP,  currentXP)
	local skillLineData = SKILLS_DATA_MANAGER:GetSkillLineDataByIndices(skillType, skillIndex)

	local lastSkillXP, nextSkillXP, currentSkillXP
	local skillName, skillRank
	local CraftType
	local icon 		 = "/esoui/art/skillsadvisor/indicator_abilitymorph.dds"
	local cSkillName = ""

	local WHITEcolor    = "|cFFFFFF"
	local GREYcolor	    = "|c808080"
	local REDcolor	  	= "|cFF0000"
	local YELLOWcolor 	= "|cFFFF00"
	local GREENcolor	= "|c35fc38"

	lastSkillXP, nextSkillXP, currentSkillXP = GetSkillLineXPInfo(skillType, skillIndex)
	skillName, skillRank          	         = GetSkillLineInfo(skillType, skillIndex)

	isActive = skillLineData:IsActive() and true or false

	local maxedSkill = (nextSkillXP == 0)

	--Skill Xp from craft
	if (( skillType == SKILL_TYPE_TRADESKILL ) and (reason == PROGRESS_REASON_TRADESKILL)) then
		if not DsRGuildLoot.sV.ChatXPcrafting then return end
		CraftType  = GetCraftingInteractionType()
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0,[2]=1,[3]=0.39,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		
		if (CraftType == CRAFTING_TYPE_BLACKSMITHING) and DsRGuildLoot.sV.ChatXPblacksmithing == true then
			icon  = "/esoui/art/icons/skilllinexp_blacksmithing.dds"
		elseif (CraftType == CRAFTING_TYPE_CLOTHIER) and DsRGuildLoot.sV.ChatXPclothier == true then
			icon    = "/esoui/art/icons/skilllinexp_clothier.dds"
		elseif (CraftType == CRAFTING_TYPE_ENCHANTING) and DsRGuildLoot.sV.ChatXPenchanting == true then
			icon    = "/esoui/art/icons/skilllinexp_enchanting.dds"
		elseif (CraftType == CRAFTING_TYPE_ALCHEMY) and DsRGuildLoot.sV.ChatXPalchemy == true then
			icon    = "/esoui/art/icons/skilllinexp_alchemy.dds"
		elseif (CraftType == CRAFTING_TYPE_PROVISIONING) and DsRGuildLoot.sV.ChatXPprovisioner == true then
			icon    = "/esoui/art/icons/skilllinexp_provisioner.dds"
		elseif (CraftType == CRAFTING_TYPE_WOODWORKING) and DsRGuildLoot.sV.ChatXPwoodworking == true then
			icon    = "/esoui/art/icons/skilllinexp_woodworking.dds"
		elseif (CraftType == CRAFTING_TYPE_JEWELRYCRAFTING) and DsRGuildLoot.sV.ChatXPjewelrymaking == true then
			icon    = "/esoui/art/icons/skilllinexp_jewelrymaking.dds"
		else -- craft book
			local craftTable = {
				[1] = {icon = "/esoui/art/icons/skilllinexp_alchemy.dds"},		
				[2] = {icon = "/esoui/art/icons/skilllinexp_blacksmithing.dds"},	
				[3] = {icon = "/esoui/art/icons/skilllinexp_clothier.dds"},		
				[4] = {icon = "/esoui/art/icons/skilllinexp_enchanting.dds"},	
				[5] = {icon = "/esoui/art/icons/skilllinexp_jewelrymaking.dds"},	
				[6] = {icon = "/esoui/art/icons/skilllinexp_provisioner.dds"},	
				[7] = {icon = "/esoui/art/icons/skilllinexp_woodworking.dds"},	
			}
			icon  = (craftTable[skillIndex] ~= nil) and craftTable[skillIndex].icon or "esoui/art/mainmenu/menubar_journal_up.dds"
		end
--Skill Xp GUILD
	elseif ( skillType == SKILL_TYPE_GUILD ) then
		if maxedSkill then return end
		if not DsRGuildLoot.sV.ChatXPguild then return end
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0,[2]=1,[3]=1,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		-- 1 = Dark Brotherhood // 2 = Fighters Guild // 3 = Mages Guild // 4 = Psijic Order // 5 = Thieves Guild // 6 = Undaunted
		if (skillIndex == 1) or (skillIndex == 2) or (skillIndex == 3) or (skillIndex == 4) or (skillIndex == 5) or (skillIndex == 6) then
			icon    = skillLineData:GetAnnounceIcon()
		else
			icon    = "/esoui/art/icons/poi/poi_groupinstance_complete.dds"
		end
--Skill Xp WORLD
	elseif ( skillType == SKILL_TYPE_WORLD ) then
		if maxedSkill or not isActive then return end
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0,[2]=1,[3]=1,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		if skillIndex == 1 then -- Excavation
			if not DsRGuildLoot.sV.ChatXPexcavation == true then return end
			icon  = "/esoui/art/icons/skilllinexp_digging.dds"
		elseif skillIndex == 2 then -- Legerdemain
			if not DsRGuildLoot.sV.ChatXPlegerdemain == true then return end
			icon  = "/esoui/art/icons/skilllinexp_ledgermain.dds"
		elseif skillIndex == 3 then -- Scrying
			if not DsRGuildLoot.sV.ChatXPscrying == true then return end
			icon  = "/esoui/art/icons/skilllinexp_scrying.dds"
		elseif skillIndex == 4 then -- Soul Magic
			if not DsRGuildLoot.sV.ChatXPsoulmagic == true then return end
			icon  = "/esoui/art/icons/soulgem_006_filled.dds"
		elseif skillIndex == 5 then -- Vampire
			if not DsRGuildLoot.sV.ChatXPvampire == true then return end
			icon  = "/esoui/art/icons/ability_vampire_007.dds"
		elseif skillIndex == 6 then -- Werewolf
			if not DsRGuildLoot.sV.ChatXPwerewolf == true then return end
			icon  = "/esoui/art/icons/ability_werewolf_010.dds"
		end
--Skill Xp WEAPON PROGRESS
	elseif ( skillType == SKILL_TYPE_WEAPON ) then
		if maxedSkill or not isActive then return end
		if not DsRGuildLoot.sV.ChatXPweapon then return end
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=1,[2]=0.78,[3]=0.39,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		if skillIndex == 1 then -- Two-Handed
			icon  = "/esoui/art/icons/icon_2handed.dds"
		elseif skillIndex == 2 then -- 1-Hand & Shield
			icon  = "/esoui/art/icons/icon_1handed.dds"
		elseif skillIndex == 3 then -- Dual Wield
			icon  = "/esoui/art/icons/icon_dualwield.dds"
		elseif skillIndex == 4 then -- Bow
			icon  = "/esoui/art/icons/icon_bows.dds"
		elseif skillIndex == 5 then -- Destruction Staff
			icon  = "/esoui/art/icons/icon_firestaff.dds"
		elseif skillIndex == 6 then -- Restoration Staff
			icon  = "/esoui/art/icons/progression_tabicon_healstaff_up.dds"
		end
--Skill Xp ARMOR PROGRESS
	elseif ( skillType == SKILL_TYPE_ARMOR ) then
		if maxedSkill or not isActive then return end
		if not DsRGuildLoot.sV.ChatXParmor then return end
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0.78,[2]=0.6,[3]=1,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		if skillIndex == 1 then -- Light Armor
			icon  = "/esoui/art/icons/progression_tabicon_armorlight_up.dds"
		elseif skillIndex == 2 then	-- Medium Armor
			icon  = "/esoui/art/icons/progression_tabicon_armormedium_up.dds"
		elseif skillIndex == 3 then -- Heavy Armor
			icon  = "/esoui/art/icons/progression_tabicon_armorheavy_up.dds"
		end
--Skill Xp AvA PROGRESS
	elseif ( skillType == SKILL_TYPE_AVA ) then
		if maxedSkill or not isActive then return end
		if not DsRGuildLoot.sV.ChatXPava then return end
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=1,[2]=0.39,[3]=0.39,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		if skillIndex == 1 then -- Assault
			icon  = "/esoui/art/compass/ava_largekeep_neutral.dds"
		elseif skillIndex == 2 then	-- Emperor
			icon  = "/esoui/art/campaign/gamepad/gp_overview_menuicon_emperor.dds"
		elseif skillIndex == 3 then -- Support
			icon  = "/esoui/art/compass/ava_outpost_neutral.dds"
		end
-- Fence skill line
	elseif (reason == PROGRESS_REASON_JUSTICE_SKILL_EVENT) then
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0.78,[2]=0.78,[3]=0.39,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		icon 	   = "/esoui/art/icons/skilllinexp_ledgermain.dds"
--Skill XP from books in library
	elseif (reason == PROGRESS_REASON_SKILL_BOOK or reason == PROGRESS_REASON_BOOK_COLLECTION_COMPLETE) then
		cSkillName = '|c'..DsRGuildLoot.num2hex({[1]=0,[2]=0.39,[3]=1,[4]=1})..skillName..'|r' or '|c6BB5FF'..skillName..'|r'
		icon 	   = "/esoui/art/mainmenu/menubar_journal_up.dds"
	else
		return
	end

	local RealGain
	local SkillXp
	local SkillXpTotal

	SkillXp      = ( currentSkillXP - lastSkillXP ) -- levelCurrent
	SkillXpTotal = SkillXp
	if ( not maxedSkill ) then
		SkillXpTotal = nextSkillXP - lastSkillXP -- levelCap
	end

	RealGain = currentXP - previousXP

	local pccurrent=0
	if (SkillXpTotal > 0) then
		pccurrent = DsRGuildLoot.FormatAmount(math.floor(100*(SkillXp/SkillXpTotal)))
	end
	
	local sLevel = "Rank ".. tostring(skillRank)
	local progressMin = zo_strformat( '(<<1>>%)', pccurrent )
	local progressFull = zo_strformat( '<<1>>/<<2>> (<<3>>%)', DsRGuildLoot.FormatAmount(SkillXp), DsRGuildLoot.FormatAmount(SkillXpTotal), pccurrent )
	local lProg = ((skillLevel) and (true) and (true)) and progressFull or ((skillLevel) and (true)) and progressMin or ""

	local pctexts = ""

	if (( skillType == SKILL_TYPE_GUILD ) and ( skillIndex == 4 )) then
		pctexts = zo_strformat( '<<1>>', sLevel )
	else
		pctexts = zo_strformat( '<<1>> <<2>>', sLevel, lProg )
	end

	local lgIconText = zo_iconTextFormat(tostring(icon), 22, 22, " ")
	local OutputTXT  = zo_strformat( '|c6BB5FF+<<1>>xp|r  <<t:2>>  |c6BB5FF<<3>>|r |c736F6E<<4>>|r ', DsRGuildLoot.FormatAmount(RealGain), cSkillName, pctexts, progressFull )
	
	CHAT_SYSTEM:AddMessage(lgIconText .. OutputTXT)
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- Format change
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.FormatAmount( amount, prefix )
	local tVal = ""
	local flipVal = (amount < 0) and amount * -1 or amount

	tVal = ZO_CommaDelimitNumber( flipVal ):gsub("%,","%.")

	if (prefix) then
		tVal = (amount < 0) and "-"..tVal or "+"..tVal
	end

	return tVal
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- num 2 hex
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.num2hex(ntable)
	local cstring = ""
	for i = 1, 3, 1 do
		local colornum = ntable[i] * 255
		local hexstr = "0123456789abcdef"
		local s = ""
		while colornum > 0 do
			local mod = math.fmod(colornum, 16)
			s = string.sub(hexstr, mod+1, mod+1) .. s
			colornum = math.floor(colornum / 16)
		end
		if #s == 1 then s = "0" .. s end
		if s == "" then s = "00" end
		cstring = cstring .. s
	end
	return cstring
end

-------------------------------------------------------------------------------------------------------------------------------------------------
-- On addon loaded
-------------------------------------------------------------------------------------------------------------------------------------------------
function DsRGuildLoot.OnAddonLoaded(event, name)

	EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_LOOT_RECEIVED, DsRGuildLoot.OnLootReceived)

	EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_MAIL_READABLE, function( _, ... )  DsRGuildLoot.OnMailReadable( ... ) end)
	EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS, function( _, ... ) DsRGuildLoot.OnMailItemLooted( ... )    end)

	if DsRGuildLoot.sV.ChatXP then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_EXPERIENCE_GAIN, function( _, ... ) DsRGuildLoot.OnXPUpdated( ... ) end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_EXPERIENCE_GAIN )
	end
	if DsRGuildLoot.sV.ChatXPskills then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_SKILL_XP_UPDATE, function( ... ) DsRGuildLoot:OnSkillXPUpdated( ... ) end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_SKILL_XP_UPDATE )
	end
	if DsRGuildLoot.sV.ChatGold then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_MONEY_UPDATE, function( _, ... ) DsRGuildLoot.OnMoneyUpdated( ... )  end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_MONEY_UPDATE )
	end

	DsRGuildLoot.AccountCurrencies()

	if DsRGuildLoot.sV.ChatGroupLoot then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_GROUP_TYPE_CHANGED, function( _, ... ) DsRGuildLoot.OnGroupChanged( ... ) end )
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_GROUP_MEMBER_JOINED, function( _, ... ) DsRGuildLoot.OnGroupChanged( ... ) end )
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_GROUP_MEMBER_LEFT, function( _, ... ) DsRGuildLoot.OnGroupChanged( ... ) end )
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_GROUP_UPDATE, function( _, ... ) DsRGuildLoot.OnGroupChanged( ... ) end )
		DsRGuildLoot.OnGroupChanged()
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_GROUP_TYPE_CHANGED )
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_GROUP_MEMBER_JOINED )
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_GROUP_MEMBER_LEFT )
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_GROUP_UPDATE )
	end
	if DsRGuildLoot.sV.ChatArchivments then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_ACHIEVEMENT_AWARDED, function(_, ... ) DsRGuildLoot.AchievementComplete(...) end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_ACHIEVEMENT_AWARDED )
	end
	if DsRGuildLoot.sV.ChatArchivmentsStatus then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_ACHIEVEMENT_UPDATED, function(_, ... ) DsRGuildLoot.AchievementUpdated(...) end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_ACHIEVEMENT_UPDATED )
	end
	if DsRGuildLoot.sV.ChatBookLoot then
		EVENT_MANAGER:RegisterForEvent(DsRGuildLoot.name, EVENT_LORE_BOOK_LEARNED, function( _, ... ) DsRGuildLoot.OnLoreBookLearned( ... ) end )
	else
		EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_LORE_BOOK_LEARNED )
	end

	EVENT_MANAGER:UnregisterForEvent(DsRGuildLoot.name, EVENT_ADD_ON_LOADED)
end
